package com.huimv.production.autoGetData.entity;

import javax.persistence.*;
import java.io.Serializable;

@Entity
@Table(name = "prod_important_indicator")
public class ProdImportantIndicatorEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Integer id;

    /**
     * 存栏类型
     */
    @Column(name = "stock_type")
    private String stockType;

    /**
     * 存栏名称
     */
    @Column(name = "stock_name")
    private String stockName;

    /**
     * 存栏数量
     */
    @Column(name = "stock_quantity")
    private String stockQuantity;

    /**
     * 占比
     */
    @Column(name = "rate")
    private Float rate;

    /**
     * 月份
     */
    @Column(name = "month")
    private Integer month;

    /**
     * 年份
     */
    @Column(name = "year")
    private Integer year;

    /**
     * 牧场id
     */
    @Column(name = "farm_id")
    private Integer farmId;

    /**
     * 分区id
     */
    @Column(name = "subarea_id")
    private Integer subareaId;

    /**
     * 涨跌状态（1:上涨 0:下跌）
     */
    @Column(name = "rise_fall")
    private Integer riseFall;

    /**
     * 涨跌幅度
     */
    @Column(name = "range1")
    private String range1;

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    /**
     * 存栏类型
     */
    public void setStockType(String stockType) {
        this.stockType = stockType;
    }

    /**
     * 存栏类型
     */
    public String getStockType() {
        return stockType;
    }

    /**
     * 存栏名称
     */
    public void setStockName(String stockName) {
        this.stockName = stockName;
    }

    /**
     * 存栏名称
     */
    public String getStockName() {
        return stockName;
    }

    /**
     * 存栏数量
     */
    public void setStockQuantity(String stockQuantity) {
        this.stockQuantity = stockQuantity;
    }

    /**
     * 存栏数量
     */
    public String getStockQuantity() {
        return stockQuantity;
    }

    /**
     * 占比
     */
    public void setRate(Float rate) {
        this.rate = rate;
    }

    /**
     * 占比
     */
    public Float getRate() {
        return rate;
    }

    /**
     * 月份
     */
    public void setMonth(Integer month) {
        this.month = month;
    }

    /**
     * 月份
     */
    public Integer getMonth() {
        return month;
    }

    /**
     * 年份
     */
    public void setYear(Integer year) {
        this.year = year;
    }

    /**
     * 年份
     */
    public Integer getYear() {
        return year;
    }

    /**
     * 牧场id
     */
    public void setFarmId(Integer farmId) {
        this.farmId = farmId;
    }

    /**
     * 牧场id
     */
    public Integer getFarmId() {
        return farmId;
    }

    /**
     * 分区id
     */
    public void setSubareaId(Integer subareaId) {
        this.subareaId = subareaId;
    }

    /**
     * 分区id
     */
    public Integer getSubareaId() {
        return subareaId;
    }

    /**
     * 涨跌状态（1:上涨 0:下跌）
     */
    public void setRiseFall(Integer riseFall) {
        this.riseFall = riseFall;
    }

    /**
     * 涨跌状态（1:上涨 0:下跌）
     */
    public Integer getRiseFall() {
        return riseFall;
    }

    /**
     * 涨跌幅度
     */
    public void setRange1(String range) {
        this.range1 = range;
    }

    /**
     * 涨跌幅度
     */
    public String getRange1() {
        return range1;
    }

    @Override
    public String toString() {
        return "ProdImportantIndicatorEntity{" +
                "id=" + id + '\'' +
                "stockType=" + stockType + '\'' +
                "stockName=" + stockName + '\'' +
                "stockQuantity=" + stockQuantity + '\'' +
                "rate=" + rate + '\'' +
                "month=" + month + '\'' +
                "year=" + year + '\'' +
                "farmId=" + farmId + '\'' +
                "subareaId=" + subareaId + '\'' +
                "riseFall=" + riseFall + '\'' +
                "range1=" + range1 + '\'' +
                '}';
    }
}
