package com.huimv.production.datasource.dao.repo;

import com.huimv.production.datasource.dao.entity.TDeliveryEntity;
import org.joda.time.DateTime;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.Date;
import java.util.List;

public interface TDeliveryRepo extends JpaRepository<TDeliveryEntity, String>, JpaSpecificationExecutor<TDeliveryEntity> {
   
    /**
     * @Method      : getPsy
     * @Description : Psy
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 13:50
     */
    @Query(nativeQuery = true,value = "SELECT CAST " +
            "( " +
            "PJWCHZ * chl * NCWS AS DEC ( 8, 2 )) AS 'PSY'  " +
            "FROM " +
            "( " +
            "SELECT " +
            " CAST " +
            "( " +
            " (AVG " +
            "( TNewStru7743.FamountLiveInt* 1.0 )) AS DEC ( 8, 2 )) AS 'PJWCHZ'  " +
            "FROM " +
            "TDelivery " +
            "LEFT JOIN TNewStru7743 ON TNewStru7743.FDeliveryMainStruID= TDelivery.FID  " +
            "WHERE " +
            "TDelivery.FLogStatee IN ( 3, 4, 6 )  " +
            "AND ( datediff( dd,  ?1, TDelivery.FDATEDELIVERY ) >= 0 )  " +
            "AND ( datediff( dd,  ?2, TDelivery.FDATEDELIVERY ) <= 0 )  " +
            "and (TDelivery.hogpenDID in( ?3)) " +
            ") PJWCHZ, " +
            "( " +
            "SELECT " +
            "CASE " +
            "WHEN " +
            "zczc = 0 THEN " +
            "0 ELSE 1-sw / zczc  " +
            "END AS 'chl'  " +
            "FROM " +
            "( " +
            "SELECT COUNT " +
            "( TBornNewStru.Fid ) AS 'zczc'  " +
            "FROM " +
            "TBorn " +
            "LEFT JOIN TBornNewStru ON TBornNewStru.FBornMainStruID = TBorn.FID  " +
            "WHERE " +
            "TBorn.FLOGSTATEE IN ( 3, 4, 6 )  " +
            "AND ( datediff( dd,  ?1, TBorn.FDATEBORN ) >= 0 )  " +
            "AND ( datediff( dd,  ?2, TBorn.FDATEBORN ) <= 0 ) " +
            "and TBorn.HOGPENDID in ( ?3)  " +
            ") cs, " +
            "( " +
            "SELECT SUM " +
            "( " +
            "isnull( TPigDieChild.FweakpigdieCount, 0 )) + SUM ( " +
            "isnull( TPigDieChild.Fpigdiecount, 0 )) AS sw  " +
            "FROM " +
            "TPigDie " +
            "LEFT JOIN TPigDieChild ON TPigDieChild.FPigDieMainStruID= TPigDie.FID  " +
            "WHERE " +
            "TPigDie.FBillState IN ( 3, 4, 6 )  " +
            "AND TPigDieChild.FPigSex IN ( 1, 2, 3 )  " +
            "AND FPIGSTATE = 15  " +
            "AND ( TPigDie.FDieDate BETWEEN  ?1 AND  ?2 ) " +
            "and (TPigdie.PIGHOUSEID in ( ?3)) " +
            ") sw  " +
            ") chl, " +
            "( " +
            "SELECT  " +
            " " +
            "CAST " +
            "( " +
            "(365/(RSQ+BRQ+dpjj+dnsts+hbpzjj)) AS DEC ( 8, 2 )) AS NCWS " +
            " FROM ( " +
            "select 母猪日均存栏 as mucl ,hbsl as hbcl,case  when ts is null then 250 else ts end as tss,RSQ AS RSQ ,BRQ AS BRQ,isnull(CAST " +
            "( " +
            "(1.0*dpjjh)/(1.0*母猪日均存栏) AS DEC ( 8, 2 )),0) as dpjj " +
            ", isnull(CAST " +
            "( " +
            "(1.0*ztjgtss)/(1.0*母猪日均存栏) AS DEC ( 8, 2 )),0) as dnsts , " +
            " " +
            "isnull(CAST " +
            "(((case  when ts is null then 250 else ts end-250)*hbsl/母猪日均存栏) as DEC ( 8, 2 ) ),0) as hbpzjj " +
            "from ( " +
            "select  " +
            "isnull(mzrjcl.RJAmount,0) as '母猪日均存栏' " +
            "from( " +
            "select tmp_tbl.ZCID, AVG(tmp_tbl.FAmount) 'RJAmount' from (select tppa.HogpendID 'ZCID' " +
            "           ,tppa.FDay 'FDate',SUM(tppa.FAmount) 'FAmount' from TPigStateAmountForBoar tppa where 1=1  " +
            "        and tppa.FDay>= ?1 " +
            "           and tppa.FDay<= ?2 and FPigClass=2 " +
            "              and tppa.HogpendID in( ?3) " +
            "           group by tppa.HogpendID,tppa.FDay) tmp_tbl group by tmp_tbl.ZCID )mzrjcl)mzcl, " +
            "            " +
            "           (SELECT   " +
            "count(sow.fnumber) as 'hbsl' " +
            "FROM TNewStru8094 " +
            "left join TBreeding on TNewStru8094.FBreedingMainStruID = TBreeding.FID   " +
            "left join TOrganizeCell on TBreeding.HOGPENDID = TOrganizeCell.FID   " +
            "left join TPigArchives as sow on TNewStru8094.SOWSTRID= sow.FID   " +
            "WHERE TBreeding.FlogStateE in (3,4,6)  " +
            "And (TBreeding.HOGPENDID in( ?3))  " +
            "And (TBreeding.FDATEBREED>= ?1 or  ?1 is null)  " +
            "And (TBreeding.FDATEBREED<= ?2 or  ?2 is null)  " +
            "   and (TNewStru8094.fuponPigStateE =11) " +
            "   )hbs, " +
            "   (select avg(hb.ts) as 'ts' from(SELECT TOrganizeCell.FNAME  as '所在猪场', TPigHouse.FName as '所在猪舍',  " +
            "       TBreeding.FDATEBREED as '配种日期', TNewStru8094.fuponPigStateE as '状态', " +
            " CAST(DATEDIFF(dd,(select top 1 FDATEOFBIRTH from TPigArchives where fnumber=sow.fnumber),TBreeding.FDATEBREED) AS DECIMAL(10,2)) as 'ts' " +
            "FROM TNewStru8094 " +
            "left join TBreeding on TNewStru8094.FBreedingMainStruID = TBreeding.FID   " +
            "left join TOrganizeCell on TBreeding.HOGPENDID = TOrganizeCell.FID   " +
            "left join TPigHouse on TBreeding.PIGHOUSEDID = TPigHouse.FID   " +
            "left join TPigArchives as sow on TNewStru8094.SOWSTRID= sow.FID   " +
            "left join TPigArchives as boar on  TNewStru8094.BOARONESTRID = boar.FID   " +
            "left join TPigArchives as boar1 on TNewStru8094.boarTwoIntID = boar1.FID  " +
            "LEFT JOIN TBreed ON boar.varietyDID = TBreed.FID  " +
            "left join TEmployee on TEmployee.FID=TNewStru8094.EMPONEBOARDID " +
            "left join TEmployee emp on emp.FID = TNewStru8094.EMPTWOBOARDID " +
            "WHERE TBreeding.FlogStateE in (3,4,6) and TNewStru8094.fuponPigStateE=11 " +
            "And (TBreeding.HOGPENDID in(''))  " +
            "And (TBreeding.FDATEBREED>= ?1 or  ?1 is null)  " +
            "And (TBreeding.FDATEBREED<= ?2 or  ?2 is null)  " +
            ")hb)hbts, " +
            "(select sum(zh.本次配种至上窝断奶天数) as 'dpjjh' from( SELECT TOrganizeCell.FNAME  as '所在猪场', " +
            "datediff(day, (select max(TWeaning.FDateWeaning) from TWeaning left join TWeaningNewStru on TWeaningNewStru.FWeaningMainStruID=TWeaning.FID  " +
            "where TWeaning.FlogStateE in (3,4,6) and TWeaningNewStru.SOWSTRID=TNewStru8094.SOWSTRID  " +
            "and TWeaningNewStru.FParityInt=TNewStru8094.FParityInt), TBreeding.FDateBreed) as '本次配种至上窝断奶天数'  " +
            "FROM TNewStru8094 " +
            "left join TBreeding on TNewStru8094.FBreedingMainStruID = TBreeding.FID   " +
            "left join TOrganizeCell on TBreeding.HOGPENDID = TOrganizeCell.FID   " +
            "WHERE TBreeding.FlogStateE in (3,4,6)  " +
            "And (TBreeding.HOGPENDID in( ?3))  " +
            "And (TBreeding.FDATEBREED>= ?1 or  ?1 is null)  " +
            "And (TBreeding.FDATEBREED<= ?2 or  ?2 is null)  " +
            "group by TOrganizeCell.FNAME,TNewStru8094.SOWSTRID,TNewStru8094.FPARITYINT,TBreeding.FDATEBREED)zh)zhs " +
            ", " +
            "( select sum(zh.ztjgts) as 'ztjgtss' from (SELECT  DATEDIFF(dd,TDL.ztbgrq , max(TDL.rq)) as 'ztjgts' " +
            "  from(   " +
            "  SELECT  " +
            "  TPigArchives.FNUMBER as 'zzbh',     " +
            "  TPigdie.FDIEDATE as 'rq', " +
            "case    " +
            "  when TPigdieChild.FPIGSTATE = 3 then (select MAX(TWeaning.FDATEWEANING)  from TWeaning ,TWeaningNewStru  " +
            "  where TWeaning.FDATEWEANING <=TPigdie.FDIEDATE  " +
            "  and TWeaning.FID = TWeaningNewStru.FWeaningMainStruID " +
            "  and TWeaningNewStru.SOWSTRID = TPigdieChild.NUMBERID " +
            "   )    end as 'ztbgrq'  " +
            "  FROM TPigdie  " +
            "  left join TPigdieChild on TPigdie.FID=TPigdieChild.FPigdieMainStruID  " +
            "  left join TPigArchives on TPigdieChild.NUMBERID = TPigArchives.FID  " +
            "  WHERE TPigdie.Fbillstate in(3,4,6)  " +
            "  AND (TPigdie.PIGHOUSEID in( ?3)) " +
            "And ( datediff(dd, ?1,TPigdie.FDIEDATE)>=0 or  ?1 is null)  " +
            "And (datediff(dd, ?2,TPigdie.FDIEDATE)<=0 or  ?2 is null)  " +
            "  AND (TPigdieChild.FPIGSEX =2)  " +
            "  AND (TPigdieChild.FPIGSTATE =3)  " +
            "  union all  " +
            "  SELECT   " +
            "  TPigArchives.FNumber as 'zzbh',   " +
            "  TPigLose.FPIGLOSEDATE as 'rq', " +
            "case   " +
            "  when TPigLoseChild.FPIGSTATE = 3 then (select MAX(TWeaning.FDATEWEANING)  from TWeaning ,TWeaningNewStru  " +
            "  where TWeaning.FDATEWEANING <=TPigLose.FPIGLOSEDATE  " +
            "  and TWeaning.FID = TWeaningNewStru.FWeaningMainStruID " +
            "  and TWeaningNewStru.SOWSTRID = TPigLoseChild.NUMBERID " +
            "   )  end as 'ztbgrq'  " +
            "  FROM TPigLose  " +
            "  left join TPigLoseChild on TPigLoseChild.FPigLoseMainStruID = TPigLose.FID  " +
            "  left join TPigArchives on TPigLoseChild.NUMBERID  = TPigArchives.FID " +
            "  WHERE TPigLose.Fbillstate in(3,4,6)  " +
            "   AND (TPigLose.PIGHOUSEID in( ?3)) " +
            "  And ( datediff(dd, ?1,TPigLose.FPIGLOSEDATE)>=0 or  ?1 is null)  " +
            "And (datediff(dd, ?2,TPigLose.FPIGLOSEDATE)<=0 or  ?2 is null)  " +
            "  AND (TPigLoseChild.FSEX =2)  " +
            "  AND (TPigLoseChild.FPIGSTATE =3) ) TDL   " +
            "  GROUP BY   TDL.zzbh , TDL.ztbgrq)zh)dnst,(select  avg(DATEDIFF(day,TNewStru7743.FDATEBREED,TDelivery.FDATEDELIVERY)) as 'RSQ' " +
            "from TDelivery  " +
            "left join TNewStru7743 on TNewStru7743.FDeliveryMainStruID=TDelivery.FID  " +
            " where FLogStatee in(3,4,6) and isnull(FPREGNANTDAYINT,0)>0 " +
            "and (TDelivery.hogpendID in( ?3)) and TDelivery.FDateDelivery between  ?1 and  ?2)TRSQ " +
            ",(select avg(isnull(TWeaningNewStru.FDAYAGE,0)) as 'BRQ'  from TWeaning  " +
            "left join TWeaningNewStru on TWeaningNewStru.FWeaningMainStruID=TWeaning.FID where FLogStatee in(3,4,6)  " +
            "and isnull(TWeaningNewStru.FDAYAGE,0)>0 " +
            "and (TWeaning.hogpendID in( ?3))     " +
            "and TWeaning.FdateWeaning between  ?1 and  ?2)TBTQ)ZZ " +
            ") ncws")
    List<Object[]> getPsy(String startDate,String endDate,String farmID);

    /**
     * @Method      : getReEstrusRate
     * @Description : 返情率
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     *
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15
     * @Time        : 13:50
     */

    @Query(nativeQuery = true,value =
            "SELECT " +
                    "(select TOrganizeCell.FNAME from TOrganizeCell where FID in ( tmp_tblpz.HogpendID)) AS '猪场',    " +
                    "CAST (  " +
                    "COUNT ( tmp_tblfm.SowStrID ) * 1.0 /  " +
                    "( CASE SUM ( tmp_tblpz.配种次数 ) WHEN 0 THEN NULL ELSE SUM ( tmp_tblpz.配种次数 ) END )  " +
                    "AS DEC ( 8, 5 ) " +
                    ") AS '配种返情率'  " +
                    "FROM " +
                    "( " +
                    "SELECT " +
                    "TBreeding.HogpendID,    " +
                    "TNewStru8094.FBreedD,     " +
                    "TNewStru8094.SowStrID,     " +
                    "TNewStru8094.FParityInt,      " +
                    "COUNT ( TNewStru8094.FID ) AS '配种次数'  " +
                    "FROM " +
                    "TBreeding   " +
                    "LEFT JOIN TNewStru8094    " +
                    "ON TNewStru8094.FBreedingMainStruID= TBreeding.FID    " +
                    "WHERE " +
                    "TBreeding.FLogStatee IN ( 3, 4, 6 )     " +
                    "AND datediff( dd,?1, FDateBreed ) >=- 121    " +
                    "AND datediff( dd,?2, FDateBreed ) <=- 121    " +
                    "AND ( " +
                    "TBreeding.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)))    " +
                    "GROUP BY " +
                    "TBreeding.HogpendID,    " +
                    "TNewStru8094.FBreedD,    " +
                    "TNewStru8094.SowStrID,     " +
                    "TNewStru8094.FParityInt     " +
                    ") tmp_tblpz " +
                    "LEFT JOIN ( " +
                    "SELECT " +
                    "TReturnEstrusewStru.SowStrID,    " +
                    "TReturnEstrusewStru.FParityInt    " +
                    "FROM " +
                    "TReturnEstrusewStru    " +
                    "LEFT JOIN TReturnEstrus  " +
                    "ON TReturnEstrusewStru.FReturnEstrusMainStruID= TReturnEstrus.FID   " +
                    "WHERE " +
                    "TReturnEstrus.FLogStatee IN ( 3, 4, 6 )     " +
                    "AND datediff( dd,?1, TReturnEstrusewStru.FDateBreed ) >=- 121    " +
                    "AND datediff( dd,?2, TReturnEstrusewStru.FDateBreed ) <=- 121    " +
                    "AND ( TReturnEstrus.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3))    " +
                    ") UNION ALL " +
                    "SELECT " +
                    "TNullPregnantNewStru.SowStrID,  " +
                    "TNullPregnantNewStru.FParityInt   " +
                    "FROM " +
                    "TNullPregnantNewStru   " +
                    "LEFT JOIN TNullPregnant  " +
                    "ON TNullPregnantNewStru.FNullPregnantMainStruID= TNullPregnant.FID  " +
                    "WHERE " +
                    "TNullPregnant.FLogStatee IN ( 3, 4, 6 )   " +
                    "AND datediff( dd,?1, TNullPregnantNewStru.FDateBreed ) >=- 121   " +
                    "AND datediff( dd,?2, TNullPregnantNewStru.FDateBreed ) <=- 121     " +
                    "AND ( TNullPregnant.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)) )    " +
                    ") tmp_tblfm ON tmp_tblpz.SowStrID= tmp_tblfm.SowStrID  " +
                    "AND tmp_tblpz.FParityInt= tmp_tblfm.FParityInt  " +
                    "GROUP BY " +
                    "tmp_tblpz.HogpendID ")
    List<Object[]> getReEstrusRate(String startDate,String endDate,String farmName);

    /**
     * @Method      : getParturitionRate
     * @Description : 分娩率
     * @Params      : [startDate, endDate]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 14:43
     */
    @Query(nativeQuery = true,value ="select TOrganizeCell.FSHORTNAME as 'farm', tmp_tblpz.FBreedD as 'variety', " +
            "CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.mate_times) when 0 then null else sum(tmp_tblpz.mate_times) end) as dec(8,5)) as 'parturition_rate' " +
            "from (select " +
            "TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as 'mate_times' " +
            "from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID " +
            "where TBreeding.FLogStatee in(3,4,6) and datediff(dd, ?1, FDateBreed)>=-121 and datediff(dd, ?2,FDateBreed) <=-121 " +
            "group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt " +
            ") tmp_tblpz " +
            "left join (select TNewStru7743.SowStrID,TNewStru7743.FParityInt from TNewStru7743 " +
            "left join TDelivery on TNewStru7743.FDeliveryMainStruID=TDelivery.FID " +
            "where TDelivery.FLogStatee in(3,4,6)  and datediff(dd, ?1, TNewStru7743.FDateBreed )>=-121 " +
            "and datediff(dd, ?2,TNewStru7743.FDateBreed ) <=-121 " +
            ") tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt " +
            "left join TOrganizeCell on tmp_tblpz.HogpendID=TOrganizeCell.FID " +
            "where TOrganizeCell.FNAME is not null " +
            "group by TOrganizeCell.FSHORTNAME,tmp_tblpz.FBreedD")
    List<Object[]> getParturitionRate_old(String startDate, String endDate);

    @Query(nativeQuery = true,value ="SELECT " +
            "(select TOrganizeCell.FNAME from TOrganizeCell where FID in (  tmp_tblpz.HogpendID)) AS '猪场', " +
            "CAST ( " +
            "COUNT ( tmp_tblfm.SowStrID ) * 1.0 / ( CASE SUM ( tmp_tblpz.配种次数 ) WHEN 0 THEN NULL ELSE SUM ( tmp_tblpz.配种次数 ) END ) AS DEC ( 8, 5 )) AS '分娩率'  " +
            "FROM " +
            "( " +
            "SELECT " +
            "TBreeding.HogpendID, " +
            "TNewStru8094.FBreedD, " +
            "TNewStru8094.SowStrID, " +
            "TNewStru8094.FParityInt, " +
            "COUNT ( TNewStru8094.FID ) AS '配种次数'  " +
            "FROM " +
            "TBreeding " +
            "LEFT JOIN TNewStru8094 ON TNewStru8094.FBreedingMainStruID= TBreeding.FID  " +
            "WHERE " +
            "TBreeding.FLogStatee IN ( 3, 4, 6 )  " +
            "AND datediff( dd,?1, FDateBreed ) >=- 121  " +
            "AND datediff( dd,?2, FDateBreed ) <=- 121  " +
            "AND ( " +
            "TBreeding.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)))  " +
            "GROUP BY " +
            "TBreeding.HogpendID, " +
            "TNewStru8094.FBreedD, " +
            "TNewStru8094.SowStrID, " +
            "TNewStru8094.FParityInt  " +
            ") tmp_tblpz " +
            "LEFT JOIN ( " +
            "SELECT " +
            "TNewStru7743.SowStrID, " +
            "TNewStru7743.FParityInt  " +
            "FROM " +
            "TNewStru7743 " +
            "LEFT JOIN TDelivery ON TNewStru7743.FDeliveryMainStruID= TDelivery.FID  " +
            "WHERE " +
            "TDelivery.FLogStatee IN ( 3, 4, 6 )  " +
            "AND datediff( dd,?1, TNewStru7743.FDateBreed ) >=- 121  " +
            "AND datediff( dd,?2, TNewStru7743.FDateBreed ) <=- 121  " +
            "AND ( TDelivery.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)) )  " +
            ") tmp_tblfm ON tmp_tblpz.SowStrID= tmp_tblfm.SowStrID  " +
            "AND tmp_tblpz.FParityInt= tmp_tblfm.FParityInt  " +
            "GROUP BY " +
            "tmp_tblpz.HogpendID ")
    List<Object[]> getParturitionRate(String startDate, String endDate,String farmName);
    
    /**
     * @Method      : getStorage
     * @Description : 各种存栏
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 14:57
     */
    @Query(nativeQuery = true,value ="SELECT oc.FSHORTNAME as 'farm',tb.FNAME as 'name',COUNT(tp.FID) as 'quantity' FROM (select TOrganizeCell.FID,TOrganizeCell.FSHORTNAME from  TOrganizeCell) oc RIGHT " +
            "JOIN TPigArchives tp ON tp.HOGPENWHEREDID = oc.FID  " +
            "RIGHT JOIN TBreed tb ON tb.FID = tp.VARIETYDID GROUP BY oc.FSHORTNAME,tb.FNAME ")
    List<Object[]> getStorage_old();

    @Query(nativeQuery = true,value ="select  " +
            "TOrganizeCell.FNAME as 猪场, " +
            "TBreed.FName as 'PZID',  " +
            "sum(FamountChangeInt) as 'ZZNUM'  " +
            "from TStockHistory  " +
            "left join TBreed on TStockHistory.breedDid=TBreed.FID  " +
            "left join TOrganizeCell on HogpendID=TOrganizeCell.FID  " +
            "where FpigClassE in(1,2)  and breedDid is not null and HogpendID in(select FID from TOrganizeCell where FNAME in (?1))  " +
            "group by TBreed.FName,TOrganizeCell.FNAME")
    List<Object[]> getStorage(String farmName);

    /**
     * @Method      : getPigletInfo
     * @Description : 均产仔数，仔猪存活率
     * @Params      : [startDate, endDate]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 15:17
     */
    @Query(nativeQuery = true,value ="SELECT " +
            "( SELECT FSHORTNAME FROM dbo.TOrganizeCell WHERE FID = td.HOGPENDID ) AS 'farm'," +
            "COUNT ( tn.SOWSTRID ) AS 'birth_number', " +
            "SUM ( tn.FAMOUNTKITTENINT ) AS 'total', " +
            "ISNULL(tdie.csamount,0)+ISNULL(tlose.csamount,0) AS 'dead_quantity'  " +
            "FROM  " +
            "dbo.TDelivery td  " +
            "LEFT JOIN dbo.TNewStru7743 tn ON tn.FDeliveryMainStruID = td.FID  " +
            "LEFT JOIN (SELECT isnull(sum(isnull(FPIGDIECOUNT,0)+isnull(FWEAKPIGDIECOUNT,0)),0) as csamount,PIGHOUSEID FROM TPigdieChild,TPigdie WHERE  " +
            "FPigdieMainStruID = TPigdie.FID  " +
            "AND FDIEDATE BETWEEN ?1   " +
            "AND ?2  " +
            "and FPIGSEX = 3 AND FPIGSTATE = 15  " +
            "GROUP BY  " +
            "PIGHOUSEID ) tdie on tdie.PIGHOUSEID = td.HOGPENDID  " +
            "LEFT JOIN (SELECT isnull(ISNULL(sum(TPigLoseChild.FpigLoseCount),0)+ISNULL(sum(TPigLoseChild.FweakPigLoseCount),0),0) as csamount,PIGHOUSEID FROM TPigLoseChild,  " +
            "TPigLose  " +
            "WHERE  " +
            "FPigLoseMainStruID = TPigLose.FID  " +
            "AND FPIGLOSEDATE BETWEEN ?1  " +
            "AND ?2  " +
            "AND FSEX = 3  " +
            "AND FPIGSTATE = 15  " +
            "GROUP BY  " +
            "PIGHOUSEID ) tlose on tlose.PIGHOUSEID = td.HOGPENDID  " +
            "WHERE  " +
            "td.FLOGSTATEE IN ( 3, 4, 6 )   " +
            "AND datediff( dd, ?1, td.FDATEDELIVERY ) >= 0   " +
            "AND datediff( dd, ?2, td.FDATEDELIVERY ) <= 0  " +
            "GROUP BY td.HOGPENDID,tdie.csamount, tlose.csamount")
    List<Object[]> getPigletInfo_old(String startDate, String endDate);

    @Query(nativeQuery = true,value ="SELECT  " +
            "( SELECT FSHORTNAME FROM dbo.TOrganizeCell WHERE FID = td.HOGPENDID ) AS '猪场', " +
            "COUNT ( tn.SOWSTRID ) AS '分娩头数', " +
            "SUM ( tn.FAMOUNTKITTENINT ) AS '产仔总数', " +
            "ISNULL(tdie.csamount,0)+ISNULL(tlose.csamount,0) AS '仔猪死淘数' " +
            "FROM " +
            "dbo.TDelivery td " +
            "LEFT JOIN dbo.TNewStru7743 tn ON tn.FDeliveryMainStruID = td.FID  " +
            "LEFT JOIN (SELECT isnull(sum(isnull(FPIGDIECOUNT,0)+isnull(FWEAKPIGDIECOUNT,0)),0) as csamount,PIGHOUSEID FROM TPigdieChild,TPigdie WHERE " +
            "FPigdieMainStruID = TPigdie.FID  " +
            "AND FDIEDATE BETWEEN ?1  " +
            "AND ?2 " +
            "and FPIGSEX = 3 AND FPIGSTATE = 15 and  TPigDie.FBillState in(3,4,6) " +
            "GROUP BY " +
            "PIGHOUSEID ) tdie on tdie.PIGHOUSEID = td.HOGPENDID " +
            "LEFT JOIN (SELECT isnull(ISNULL(sum(TPigLoseChild.FpigLoseCount),0)+ISNULL(sum(TPigLoseChild.FweakPigLoseCount),0),0) as csamount,PIGHOUSEID FROM TPigLoseChild, " +
            "TPigLose  " +
            "WHERE " +
            "FPigLoseMainStruID = TPigLose.FID  " +
            "AND FPIGLOSEDATE BETWEEN ?1  " +
            "AND ?2  " +
            "AND FSEX = 3  " +
            "AND FPIGSTATE = 15 and TPigLose.FBillState in(3,4,6) " +
            "GROUP BY " +
            "PIGHOUSEID ) tlose on tlose.PIGHOUSEID = td.HOGPENDID " +
            "WHERE " +
            "td.FLOGSTATEE IN ( 3, 4, 6 )  " +
            "AND datediff( dd, ?1, td.FDATEDELIVERY ) >= 0  " +
            "AND datediff( dd, ?2, td.FDATEDELIVERY ) <= 0  " +
            "AND td.HOGPENDID IN (select FID from TOrganizeCell where FNAME in (?3))  " +
            "GROUP BY " +
            "td.HOGPENDID, " +
            "tdie.csamount, " +
            "tlose.csamount")
    List<Object[]> getPigletInfo(String startDate, String endDate,String farmName);

    /**
     * @Method      : getMateQuantity
     * @Description : 配种数量
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 15:47
     */
    @Query(nativeQuery = true,value ="select TOrganizeCell.FSHORTNAME as 'farm', tmp_tblpzts.FBREEDD AS 'variety', sum(tmp_tblpzts.mate_times) as 'mate_quantity' from (select  " +
            "TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as 'mate_times'  " +
            "from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID  " +
            "where TBreeding.FLogStatee in(3,4,6)  and datediff(dd,?1, FDateBreed)>=0 and datediff(dd,?2,FDateBreed) <=0  " +
            "group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt  " +
            ") tmp_tblpzts  left join TOrganizeCell on tmp_tblpzts.HogpendID=TOrganizeCell.FID " +
            "where TOrganizeCell.FNAME is not null group by TOrganizeCell.FSHORTNAME,tmp_tblpzts.FBREEDD")
    List<Object[]> getMateQuantity_old(String startDate, String endDate);


    @Query(nativeQuery = true,value ="SELECT  " +
            "  (SELECT TOrganizeCell.FNAME FROM TOrganizeCell WHERE FID IN( tmp_tblpzts.HogpendID)) AS '猪场',  " +
            "  SUM ( tmp_tblpzts.配种次数 ) AS '配种头数'   " +
            " FROM  " +
            "  (  " +
            "  SELECT  " +
            "   TBreeding.HogpendID,  " +
            "   TNewStru8094.FBreedD,  " +
            "   TNewStru8094.SowStrID,  " +
            "   TNewStru8094.FParityInt,  " +
            "   COUNT ( TNewStru8094.FID ) AS '配种次数'   " +
            "  FROM  " +
            "   TBreeding  " +
            "   LEFT JOIN TNewStru8094 ON TNewStru8094.FBreedingMainStruID= TBreeding.FID   " +
            "  WHERE  " +
            "   TBreeding.FLogStatee IN ( 3, 4, 6 )   " +
            "   AND datediff( dd,?1, FDateBreed ) >= 0   " +
            "   AND datediff( dd,?2, FDateBreed ) <= 0   " +
            "   AND (  " +
            "   TBreeding.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)))   " +
            "  GROUP BY  " +
            "   TBreeding.HogpendID,  " +
            "   TNewStru8094.FBreedD,  " +
            "   TNewStru8094.SowStrID,  " +
            "   TNewStru8094.FParityInt   " +
            "  ) tmp_tblpzts   " +
            " GROUP BY  " +
            "  tmp_tblpzts.HogpendID ")
    List<Object[]> getMateQuantity(String startDate, String endDate,String farmName);

    /**
     * @Method      : getConceptionRate
     * @Description : 受胎率
     * @Params      : [startDate, endDate]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 16:15
     */
    @Query(nativeQuery = true,value =" select " +
            " TOrganizeCell.FshortName as '猪场', " +
            "  CAST((tmp_tblpz.fmts+isnull(tmp_tblpzlc.lcts,0))*1.0/tmp_tblpz.pzts*100 as dec(8,2)) as '受胎率' " +
            "  from " +
            "    (select tmp_tblpz.HogpendID as 'ZCID',sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'fmts'," +
            "  CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML' " +
            "  from (select " +
            " TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数' " +
            " from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID " +
            "  where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2) " +
            " group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt " +
            " ) tmp_tblpz " +
            " left join (select TNewStru7743.SowStrID,TNewStru7743.FParityInt from TNewStru7743 " +
            "  left join TDelivery on TNewStru7743.FDeliveryMainStruID=TDelivery.FID " +
            "  where TDelivery.FLogStatee in(3,4,6)  and TNewStru7743.FDateBreed>=DATEADD(DAY,-121,?1) and TNewStru7743.FDateBreed<=DATEADD(DAY,-121,?2)  " +
            "  ) tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt " +
            "  group by tmp_tblpz.HogpendID) tmp_tblpz  " +
            " left join (select tmp_tblpz.HogpendID as 'ZCID', sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'lcts'," +
            " CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML' " +
            " from (select " +
            "  TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数' " +
            "  from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID " +
            " where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2) " +
            "  group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt " +
            "  ) tmp_tblpz " +
            "  left join (select TAbortionNewStru.SowStrID,TAbortionNewStru.FParityInt from TAbortionNewStru " +
            " left join TAbortion on TAbortionNewStru.FAbortionMainStruID=TAbortion.FID " +
            " where TAbortion.FLogStatee in(3,4,6)  and TAbortionNewStru.FDateBreed>=DATEADD(DAY,-121,?1) and TAbortionNewStru.FDateBreed<=DATEADD(DAY,-121,?2)  " +
            " ) tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt " +
            " group by tmp_tblpz.HogpendID) tmp_tblpzlc on tmp_tblpzlc.ZCID=tmp_tblpz.ZCID " +
            " left join TOrganizeCell on tmp_tblpz.ZCID=TOrganizeCell.FID " +
            " where TOrganizeCell.FNAME in(?3)")
    List<Object[]> getConceptionRate(String startDate, String endDate,String farmName);

    @Query(nativeQuery = true,value =" select   " +
            "  TOrganizeCell.FshortName 'ZCNAME',  " +
            "  CAST((tmp_tblpz.fmts+isnull(tmp_tblpzlc.lcts,0))*1.0/tmp_tblpz.pzts*100 as dec(8,2)) as 受胎率  " +
            "   from  " +
            "    (select tmp_tblpz.HogpendID as 'ZCID', sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'fmts',  " +
            "  CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML'   " +
            "  from (select   " +
            " TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数'   " +
            " from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID   " +
            "  where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2)   " +
            " and (TBreeding.hogpenDID  in(select FID from TOrganizeCell where FNAME in (?3)))   " +
            "  group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt   " +
            " ) tmp_tblpz   " +
            " left join (select TNewStru7743.SowStrID,TNewStru7743.FParityInt from TNewStru7743   " +
            "  left join TDelivery on TNewStru7743.FDeliveryMainStruID=TDelivery.FID   " +
            "  where TDelivery.FLogStatee in(3,4,6)  and TNewStru7743.FDateBreed>=DATEADD(DAY,-121,?1) and TNewStru7743.FDateBreed<=DATEADD(DAY,-121,?2)  and (TDelivery.hogpenDID  in('EFB8649C-ED89-4174-A1E7-D6BA4B238992') )   " +
            "  ) tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt   " +
            "  group by tmp_tblpz.HogpendID ) tmp_tblpz    " +
            " left join (select tmp_tblpz.HogpendID as 'ZCID', sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'fqts',  " +
            " CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML'   " +
            " from (select   " +
            " TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数'   " +
            "  from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID   " +
            " where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2)   " +
            "  and (TBreeding.hogpenDID  in(select FID from TOrganizeCell where FNAME in (?3)))   " +
            "  group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt   " +
            "  ) tmp_tblpz   " +
            " left join (select TReturnEstrusewStru.SowStrID,TReturnEstrusewStru.FParityInt from TReturnEstrusewStru   " +
            " left join TReturnEstrus on TReturnEstrusewStru.FReturnEstrusMainStruID=TReturnEstrus.FID   " +
            " where TReturnEstrus.FLogStatee in(3,4,6)  and TReturnEstrusewStru.FDateBreed>=DATEADD(DAY,-121,?1) and TReturnEstrusewStru.FDateBreed<=DATEADD(DAY,-121,?2)    " +
            "  and (TReturnEstrus.hogpenDID  in('EFB8649C-ED89-4174-A1E7-D6BA4B238992') )   " +
            ") tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt   " +
            " group by tmp_tblpz.HogpendID ) tmp_tblpzfq on tmp_tblpzfq.ZCID=tmp_tblpz.ZCID  " +
            " left join (select tmp_tblpz.HogpendID as 'ZCID', sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'lcts',  " +
            " CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML'   " +
            " from (select   " +
            "  TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数'   " +
            "  from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID   " +
            "  where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2)   " +
            " and (TBreeding.hogpenDID  in(select FID from TOrganizeCell where FNAME in (?3)))   " +
            "  group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt   " +
            "  ) tmp_tblpz   " +
            "  left join (select TAbortionNewStru.SowStrID,TAbortionNewStru.FParityInt from TAbortionNewStru   " +
            " left join TAbortion on TAbortionNewStru.FAbortionMainStruID=TAbortion.FID   " +
            "where TAbortion.FLogStatee in(3,4,6)  and TAbortionNewStru.FDateBreed>=DATEADD(DAY,-121,?1) and TAbortionNewStru.FDateBreed<=DATEADD(DAY,-121,?2)    " +
            "  and (TAbortion.hogpenDID  in(select FID from TOrganizeCell where FNAME in (?3)) )   " +
            " ) tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt   " +
            "  group by tmp_tblpz.HogpendID ) tmp_tblpzlc on tmp_tblpzlc.ZCID=tmp_tblpz.ZCID  " +
            "   " +
            " left join TOrganizeCell on tmp_tblpz.ZCID=TOrganizeCell.FID")
    // --0.83
    List<Object[]> getConceptionRate_new(String startDate, String endDate,String farmName);


    /**
     * @Method      : getAllStorage
     * @Description : 总存栏，母猪存栏
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 16:22
     */
    @Query(nativeQuery = true,value ="SELECT " +
            "H.FNAME AS 'farm', " +
            "mzcl AS 'sow_quantity', " +
            "gz + mzcl + jc + shbamount AS 'total'  " +
            "FROM (SELECT " +
            "TOrganizeCell.FID, " +
            "TOrganizeCell.FName  " +
            "FROM TOrganizeCell  " +
            "GROUP BY " +
            "TOrganizeCell.FName, " +
            "TOrganizeCell.FID  " +
            ") H RIGHT JOIN ( " +
            "SELECT " +
            "tblz_tmp.FNAME AS NAME, " +
            "isnull( SUM( tblz_tmp.gz ), 0 ) AS 'gz', " +
            "isnull( sum( tblz_tmp.mzcl ), 0 ) AS 'mzcl', " +
            "isnull( SUM( tblz_tmp.jc ), 0 ) AS 'jc', " +
            "isnull( SUM( tblz_tmp.shbamount ), 0 ) AS 'shbamount'  " +
            "FROM ( SELECT " +
            "TPigArchives.HOGPENWHEREDID 'FNAME', " +
            "CASE " +
            "WHEN TPigArchives.FPIGSTATEE IN ( 2, 11 )  " +
            "AND TPigArchives.FPigClassEnum = 1 THEN " +
            "COUNT( TPigArchives.FID )  " +
            "END AS 'gz', " +
            "CASE " +
            "WHEN TPigArchives.FPigStatee IN ( 3, 4, 5, 6, 7, 10, 11, 12, 13 )  " +
            "AND TPigArchives.FPigClassEnum = 2 THEN " +
            "COUNT( TPigArchives.FID )  " +
            "END AS 'mzcl', " +
            "0 AS 'jc', " +
            "0 AS 'shbamount'  " +
            "FROM " +
            "TPigArchives  " +
            "WHERE " +
            "TPigArchives.FPigStatee IN ( 2, 3, 4, 5, 6, 7, 10, 11, 12, 13 )  " +
            "GROUP BY " +
            "TPigArchives.HOGPENWHEREDID, " +
            "TPigArchives.FPIGSTATEE, " +
            "TPigArchives.FPigClassEnum UNION ALL " +
            "SELECT " +
            "TPigArchives.HOGPENWHEREDID 'FNAME', " +
            "0 AS 'gz', " +
            "0 AS 'mzcl', " +
            "CASE " +
            "WHEN TPigArchives.FPigStatee IN ( 15, 14, 1, 21, 22, 16 ) THEN " +
            "isnull( SUM( TPigArchivesChild.FpigAmountOfPigsty ), 0 )  " +
            "END AS 'jc', " +
            "CASE " +
            "WHEN TPigArchives.FPigStatee = 11  " +
            "AND TPigArchives.FPigClassEnum = 3 THEN " +
            "isnull( SUM( TPigArchivesChild.FpigAmountOfPigsty ), 0 )  " +
            "END AS 'shbamount'  " +
            "FROM " +
            "TPigArchives " +
            "LEFT JOIN TPigArchivesChild ON TPigArchivesChild.FPigArchivesMainStruID = TPigArchives.FID  " +
            "WHERE " +
            "TPigArchives.FPigClassEnum IN ( 1, 2, 3 )  " +
            "AND TPigArchives.FBATCHSTATE = 0  " +
            "GROUP BY " +
            "TPigArchives.HOGPENWHEREDID, " +
            "TPigArchives.FPIGSTATEE, " +
            "TPigArchives.FPigClassEnum  " +
            ") tblz_tmp  " +
            "GROUP BY " +
            "tblz_tmp.FNAME  " +
            ") AS tbls_tmp ON tbls_tmp.NAME = H.fid  " +
            "ORDER BY " +
            "H.FNAME")
    List<Object[]> getAllStorage_old();

    @Query(nativeQuery = true,value ="SELECT " +
            "H.FNAME AS '猪场'," +
            "mzcl AS '母猪存栏'," +
            "gz + mzcl + jc + shbamount AS '总存栏' " +
            "FROM " +
            "(" +
            "SELECT " +
            "TOrganizeCell.FID," +
            "TOrganizeCell.FName " +
            "FROM " +
            "TOrganizeCell " +
            "GROUP BY " +
            "TOrganizeCell.FName," +
            "TOrganizeCell.FID " +
            ") H " +
            "RIGHT JOIN ( " +
            "SELECT " +
            "tblz_tmp.FNAME AS NAME," +
            "isnull( SUM( tblz_tmp.gz ), 0 ) AS 'gz'," +
            "isnull( sum( tblz_tmp.mzcl ), 0 ) AS 'mzcl'," +
            "isnull( SUM( tblz_tmp.jc ), 0 ) AS 'jc'," +
            "isnull( SUM( tblz_tmp.shbamount ), 0 ) AS 'shbamount' " +
            "FROM " +
            "(" +
            "SELECT " +
            "TPigArchives.HOGPENWHEREDID 'FNAME'," +
            "CASE " +
            "WHEN TPigArchives.FPIGSTATEE IN ( 2, 11 ) " +
            "AND TPigArchives.FPigClassEnum = 1 THEN " +
            "COUNT( TPigArchives.FID ) " +
            "END AS 'gz'," +
            "CASE " +
            "WHEN TPigArchives.FPigStatee IN ( 3, 4, 5, 6, 7, 10, 11, 12, 13 ) " +
            "AND TPigArchives.FPigClassEnum = 2 THEN " +
            "COUNT( TPigArchives.FID ) " +
            "END AS 'mzcl'," +
            "0 AS 'jc'," +
            "0 AS 'shbamount' " +
            "FROM " +
            "TPigArchives " +
            "WHERE " +
            "TPigArchives.FPigStatee IN ( 2, 3, 4, 5, 6, 7, 10, 11, 12, 13 ) " +
            "GROUP BY " +
            "TPigArchives.HOGPENWHEREDID," +
            "TPigArchives.FPIGSTATEE," +
            "TPigArchives.FPigClassEnum UNION ALL " +
            "SELECT " +
            "TPigArchives.HOGPENWHEREDID 'FNAME'," +
            "0 AS 'gz'," +
            "0 AS 'mzcl'," +
            "CASE " +
            "WHEN TPigArchives.FPigStatee IN ( 15, 14, 1, 21, 22, 16 ) THEN " +
            "isnull( SUM( TPigArchivesChild.FpigAmountOfPigsty ), 0 ) " +
            "END AS 'jc'," +
            "CASE " +
            "WHEN TPigArchives.FPigStatee = 11 " +
            "AND TPigArchives.FPigClassEnum = 3 THEN " +
            "isnull( SUM( TPigArchivesChild.FpigAmountOfPigsty ), 0 ) " +
            "END AS 'shbamount' " +
            "FROM " +
            "TPigArchives " +
            "LEFT JOIN TPigArchivesChild ON TPigArchivesChild.FPigArchivesMainStruID = TPigArchives.FID " +
            "WHERE " +
            "TPigArchives.FPigClassEnum IN ( 1, 2, 3 ) " +
            "AND TPigArchives.FBATCHSTATE = 0 " +
            "GROUP BY " +
            "TPigArchives.HOGPENWHEREDID," +
            "TPigArchives.FPIGSTATEE," +
            "TPigArchives.FPigClassEnum " +
            ") tblz_tmp " +
            "GROUP BY " +
            "tblz_tmp.FNAME " +
            ") AS tbls_tmp ON tbls_tmp.NAME = H.fid where H.FNAME in(?1) " +
            "ORDER BY " +
            "H.FNAME")
    List<Object[]> getAllStorage(String farmName);

    /**
     * @Method      : getPigletSurvivalRate
     * @Description : 猪仔存活率
     * @Params      : [startDate, endDate, farmName]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/6/30       
     * @Time        : 13:31
     */
    @Query(nativeQuery = true,value = "select  " +
            " (SELECT  CASE WHEN DATEDIFF ( dd , '2021-02-01' , '2021-03-09' ) >=31  THEN  " +
            " case when ISNULL(cszrjcl.ZCZS,0)!=0 then 1-(isnull(die.教槽,0)+isnull(lose.教槽,0))/cszrjcl.ZCZS else 0 end ELSE  " +
            " case when ISNULL(zrjcl.RJAmount,0)!=0 then 1-(isnull(die.教槽,0)+isnull(lose.教槽,0))/zrjcl.RJAmount else 0 end END )AS '仔猪存活率', " +
            " TOrganizeCell.FName 'ZCNAME' " +
            "from(select tmp_tblcl.ZCID as 'ZCID',sum(tmp_tblcl.ZCL) as 'ZCL',sum(tmp_tblcl.JCMZ) as 'JCMZ',sum(tmp_tblcl.HBMZ) as 'HBMZ',sum(tmp_tblcl.GZ) as 'GZ',sum(tmp_tblcl.HBGZ) as 'HBGZ',sum(tmp_tblcl.BRZZ) as 'BRZZ',sum(tmp_tblcl.BYZ) as 'BYZ',sum(tmp_tblcl.YFZ) as 'YFZ',sum(tmp_tblcl.HBSPZ) as 'HBSPZ'  " +
            "  from(select TStockHistory.hogpenDID as 'ZCID', sum(TStockHistory.FAmountChangeInt) as 'ZCL',  " +
            "    case when TStockHistory.FPigStatee in(3,4,5,6,7,10,12,13) and TStockHistory.FPigClassE=2 then sum(TStockHistory.FAmountChangeInt) end as 'JCMZ',  " +
            "    case when TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE=2 then sum(TStockHistory.FAmountChangeInt) end as 'HBMZ',  " +
            "    case when TStockHistory.FPigStatee in(2) and TStockHistory.FPigClassE=1 then sum(TStockHistory.FAmountChangeInt) end as 'GZ',  " +
            "    case when TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE=1 then sum(TStockHistory.FAmountChangeInt) end as 'HBGZ',  " +
            "    case when TStockHistory.FPigStatee in(15) and TStockHistory.FPigClassE in (1,2,3) then sum(TStockHistory.FAmountChangeInt) end as 'BRZZ',  " +
            "    case when TStockHistory.FPigStatee in(14) and TStockHistory.FPigClassE in (1,2,3) then sum(TStockHistory.FAmountChangeInt) end as 'BYZ',  " +
            "    case when (TStockHistory.FPigStatee in(1,22,21,16) or TStockHistory.FPigStatee is null) and TStockHistory.FPigClassE in (1,2,3) then sum(TStockHistory.FAmountChangeInt) end as 'YFZ',  " +
            "    case when  TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE=3 then sum(TStockHistory.FAmountChangeInt) end as 'HBSPZ'  " +
            "   from TStockHistory where TStockHistory.FdateChange<='2021-03-09' and TStockHistory.FPigClassE in(1,2,3)  " +
            "  and (TStockHistory.hogpenDID in( ?3)) " +
            "  group by TStockHistory.hogpenDID,TStockHistory.FPigStatee,TStockHistory.FPigClassE ) tmp_tblcl group by tmp_tblcl.ZCID " +
            "  ) tmp_tblcl  " +
            "left join ( select temp.PigHouseID,sum(isnull(temp.教槽,0)) as 教槽 " +
            "  from " +
            "  (select TPigDie.PigHouseID  , " +
            "    case when TPigDieChild.FPigState in(15) and TPigDieChild.FPigSex IN(1,2,3) then sum(TPigDieChild.FweakpigdieCount)+sum(TPigDieChild.Fpigdiecount)  end'教槽'  " +
            "   from TPigDie  " +
            "    left join TPigDieChild on TPigDieChild.FPigDieMainStruID=TPigDie.FID  " +
            "   where TPigDie.FBillState in(3,4,6) and TPigDieChild.FPigSex in(1,2,3) and FPIGSTATE in (14,15,1,21,22,11,2,3,7,12,13,5,6,16) " +
            "      and TPigDie.PigHouseID in( ?3)  " +
            "   and ( datediff(dd,'2021-02-01', TPigDie.FDieDate)>=0 and datediff(dd,'2021-03-09',TPigDie.FDieDate) <=0)  " +
            "   group by TPigDieChild.FPigState,TPigDieChild.FPigSex ,TPigDie.PigHouseID  )temp " +
            "   group by temp.PigHouseID " +
            "   ) die on die.PigHouseID=tmp_tblcl.ZCID  " +
            "left join (   select temp.PigHouseID,sum(isnull(temp.教槽,0)) as 教槽 " +
            "  from " +
            "  (select TPigLose.PigHouseID, " +
            "    case when TPigLoseChild.FPigState in(15) and TPigLoseChild.FSEX IN(1,2,3) then sum(TPigLoseChild.FpigLoseCount)+sum(TPigLoseChild.FweakPigLoseCount)  end'教槽' " +
            "   from TPigLose left join TPigLoseChild on TPigLoseChild.FPigLoseMainStruID=TPigLose.FID  " +
            "   where TPigLose.FBillState in(3,4,6) and TPigLoseChild.FSEX in(1,2,3) and FPIGSTATE in (14,15,1,21,22,11,2,3,7,12,13,5,6,16) " +
            "   and TPigLose.PigHouseID in( ?3)  " +
            "    and (datediff(dd,'2021-02-01', TPigLose.Fpiglosedate )>=0 and datediff(dd,'2021-03-09',TPigLose.Fpiglosedate ) <=0)  " +
            "   group by TPigLoseChild.FPigState,TPigLoseChild.FSEX ,TPigLose.PigHouseID  )temp " +
            "   group by temp.PigHouseID " +
            "   ) lose on lose.PigHouseID=tmp_tblcl.ZCID  " +
            "left join (select tmp_zzchl.ZCID as 'ZCID',SUM(tmp_zzchl.zczc ) as 'ZCZS' from  " +
            "          (select TBorn.HOGPENDID as 'ZCID',count(TBornNewStru.FWAREPIGNOSTR) as 'zczc' " +
            "           from TBorn left join TBornNewStru on TBornNewStru.FBornMainStruID = TBorn.FID  " +
            "                      left join TPigArchives on TPigArchives.FID = TBornNewStru.PIGFIDID " +
            "           where TBorn.FLOGSTATEE in (3,4,6)  " +
            "             and TBorn.HOGPENDID in ( ?3) and  datediff(dd,'2021-02-01',TBorn.FDATEBORN)>=0 and datediff(dd,'2021-03-09',TBorn.FDATEBORN) <=0 " +
            "             group by TBorn.HOGPENDID " +
            "             ) tmp_zzchl group by tmp_zzchl.ZCID )cszrjcl on cszrjcl.ZCID=tmp_tblcl.ZCID " +
            "left join (select tmp_tbl.ZCID, AVG(tmp_tbl.FAmount) 'RJAmount' " +
            " from (select tppa.HogpendID 'ZCID',tppa.FDay 'FDate',SUM(tppa.FAmount) 'FAmount' from TPigStateAmountForGoods tppa where 1=1  " +
            "        and tppa.FDay>='2021-02-01' " +
            "           and tppa.FDay<='2021-03-09' and FPigState=15 " +
            "              and tppa.HogpendID in ( ?3) " +
            "           group by tppa.HogpendID,tppa.FDay) tmp_tbl group by tmp_tbl.ZCID )zrjcl on zrjcl.ZCID=tmp_tblcl.ZCID " +
            " left join TOrganizeCell on tmp_tblcl.ZCID=TOrganizeCell.FID ")
    List<Object[]> getPigletSurvivalRate(String startDate, String endDate, String farmID);

    @Query(nativeQuery = true,value = "select COUNT(FID) from TStockHistory")
    List<Object[]> getTStockHistory(String farmID);

    /**
     * @Method      : getPigletSurvivalRate2
     * @Description : 获取仔猪存活率
     * @Params      : [startDate, endDate, farmID]
     * @Return      : java.util.List<java.lang.Object[]>
     *
     * @Author      : ZhuoNing
     * @Date        : 2021/8/17
     * @Time        : 15:55
     */
    @Query(nativeQuery = true,value = "select \n" +
            " (SELECT  CASE WHEN DATEDIFF ( dd ,   ?1 ,   ?2 ) >=31  THEN \n" +
            "case when ISNULL(cszrjcl.ZCZS,0)!=0 then 1-(isnull(die.教槽,0)+isnull(lose.教槽,0))/cszrjcl.ZCZS else 0 end ELSE \n" +
            "case when isnull(clqc.仔猪日均存栏,0)+isnull(clbd.仔猪日均存栏,0) !=0\n" +
            "then 1-(isnull(die.教槽,0)+isnull(lose.教槽,0))/(isnull(clqc.仔猪日均存栏,0)+isnull(clbd.仔猪日均存栏,0) ) else 0 end END )AS '仔猪存活率',\n" +
            "TOrganizeCell.FName 'ZCNAME'\n" +
            "from( \n" +
            " select TStockHistory.hogpenDID as 'ZCID',   \n" +
            "  sum(case when TStockHistory.FPigStatee in(15) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '仔猪日均存栏'    \n" +
            "    from TStockHistory \n" +
            "      where  datediff(dd,  ?1, TStockHistory.FdateChange)<0  \n" +
            "                  and TStockHistory.FPigClassE in(1,2,3) \n" +
            " and (TStockHistory.hogpenDID in(  ?3) )\n" +
            " group by TStockHistory.hogpenDID)clqc \n" +
            "left join (select tmp_tblcl.ZCID as 'ZCID'\n" +
            "  ,round(avg(isnull(tmp_tblcl.仔猪日均存栏,0)*1.00000),0) as '仔猪日均存栏'\n" +
            " from(  \n" +
            " select TStockHistory.hogpenDID as 'ZCID', sum(TStockHistory.FAmountChangeInt) as 'ZCL', \n" +
            "    sum(case when TStockHistory.FPigStatee in(15) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '仔猪日均存栏', \n" +
            "    qj.time as billdate\n" +
            "    from TStockHistory \n" +
            "            left join ( select   CONVERT(varchar(10), CONVERT(datetime,   ?1)+d,120) as  [time] \n" +
            "                from\n" +
            "                (\n" +
            "                    select   top   (datediff(day,  ?1,  ?2)+1)   row_number()   \n" +
            "                    over(order   by   getdate())-1   d   from   sys.objects\n" +
            "                ) as a) qj on 1=1\n" +
            "                where TStockHistory.FdateChange<=qj.time\n" +
            "          and  datediff(dd,  ?1, TStockHistory.FdateChange)>=0  \n" +
            "                  and TStockHistory.FPigClassE in(1,2,3) \n" +
            " and (TStockHistory.hogpenDID in(  ?3) )\n" +
            " group by TStockHistory.hogpenDID,qj.time ) tmp_tblcl\n" +
            "   group by tmp_tblcl.ZCID)clbd on clqc.ZCID =clbd.ZCID\n" +
            "left join (   select temp.PigHouseID,sum(isnull(temp.教槽,0)) as 教槽\n" +
            " from\n" +
            "  (select TPigDie.PigHouseID  ,\n" +
            "   case   when TPigDieChild.FPigState in(15) and TPigDieChild.FPigSex IN(1,2,3) then sum(TPigDieChild.FweakpigdieCount)+sum(TPigDieChild.Fpigdiecount)  end'教槽'   \n" +
            "  from TPigDie \n" +
            "   left join TPigDieChild on TPigDieChild.FPigDieMainStruID=TPigDie.FID \n" +
            "  where TPigDie.FBillState in(3,4,6) and TPigDieChild.FPigSex in(1,2,3) and FPIGSTATE in (14,15,1,21,22,11,2,3,7,12,13,5,6,16)\n" +
            "     and TPigDie.PigHouseID in(  ?3) \n" +
            "  and ( datediff(dd,  ?1, TPigDie.FDieDate)>=0 and datediff(dd,  ?2,TPigDie.FDieDate) <=0) \n" +
            "  group by TPigDieChild.FPigState,TPigDieChild.FPigSex ,TPigDie.PigHouseID  )temp\n" +
            "  group by temp.PigHouseID\n" +
            "   ) die on die.PigHouseID=clqc.ZCID  \n" +
            "left join (     select temp.PigHouseID,sum(isnull(temp.教槽,0)) as 教槽\n" +
            " from\n" +
            "  (select TPigLose.PigHouseID   , \n" +
            "   case   when TPigLoseChild.FPigState in(15) and TPigLoseChild.FSEX IN(1,2,3) then sum(TPigLoseChild.FpigLoseCount)+sum(TPigLoseChild.FweakPigLoseCount)  end'教槽' \n" +
            "  from TPigLose left join TPigLoseChild on TPigLoseChild.FPigLoseMainStruID=TPigLose.FID \n" +
            "  where TPigLose.FBillState in(3,4,6) and TPigLoseChild.FSEX in(1,2,3) and FPIGSTATE in (14,15,1,21,22,11,2,3,7,12,13,5,6,16)\n" +
            "  and TPigLose.PigHouseID in(  ?3) \n" +
            "   and (datediff(dd,  ?1, TPigLose.Fpiglosedate )>=0 and datediff(dd,  ?2,TPigLose.Fpiglosedate ) <=0) \n" +
            "  group by TPigLoseChild.FPigState,TPigLoseChild.FSEX ,TPigLose.PigHouseID  )temp\n" +
            "  group by temp.PigHouseID\n" +
            "   ) lose on lose.PigHouseID=clqc.ZCID \n" +
            "left join (select tmp_zzchl.ZCID as 'ZCID',SUM(tmp_zzchl.zczc ) as 'ZCZS' from \n" +
            "          (select TBorn.HOGPENDID as 'ZCID',count(TBornNewStru.FWAREPIGNOSTR) as 'zczc'\n" +
            "           from TBorn left join TBornNewStru on TBornNewStru.FBornMainStruID = TBorn.FID \n" +
            "                      left join TPigArchives on TPigArchives.FID = TBornNewStru.PIGFIDID\n" +
            "           where TBorn.FLOGSTATEE in (3,4,6) \n" +
            "             and TBorn.HOGPENDID in (  ?3) and  datediff(dd,  ?1,TBorn.FDATEBORN)>=0 and datediff(dd,  ?2,TBorn.FDATEBORN) <=0\n" +
            "             group by TBorn.HOGPENDID\n" +
            "             ) tmp_zzchl group by tmp_zzchl.ZCID )cszrjcl on cszrjcl.ZCID=clqc.ZCID\n" +
            "left join TOrganizeCell on clqc.ZCID=TOrganizeCell.FID")
    List<Object[]> getPigletSurvivalRate2(String startDate, String endDate, String farmID);

    /**
     * @Method      : getCostWithManyFarm
     * @Description : 
     * @Params      : [month]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/11/13       
     * @Time        : 17:56
     */
    @Query(nativeQuery = true,value = "select TOrganizeCell.FSHORTNAME,FBASISPIGBATCH as '基础猪群',FCAREPIGBATCH as '保育猪群',FFATTENBOAR as '育肥',FFATTENWARE as '后备',FCOMMONCOSTS as '共同费用',TMonthCostDetailChild.FACCOUNT as '合计',TPublicCostProject.FPROJECTNAME from TMonthCostDetailChild,TPublicCostProject \n" +
            ",TMonthCostDetail,TOrganizeCell  where PUBPROJECTID=TPublicCostProject.FID \n" +
            "and TMonthCostDetail.FID=TMonthCostDetailChild.FMonthCostDetailMainStruID \n" +
            "and TMonthCostDetail.CREATEORGID=TOrganizeCell.FID \n" +
            "and TMonthCostDetail.FBILLSTATE=3 \n" +
            "and FPROJECTNAME in('饲料','防疫消毒','兽药','公摊费用项目') \n" +
            "and TMonthCostDetail.ACCOUNTPERIODID in (select FID from TAccountingPeriodData where FNAME=?1) \n" +
            "order by TOrganizeCell.FSHORTNAME,FITEM,TOrganizeCell.fid")
    List<Object[]> getCostWithManyFarm(String month);

    /**
     * @Method      : getManyFarmStock
     * @Description :
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     *
     * @Author      : ZhuoNing
     * @Date        : 2021/11/13
     * @Time        : 18:44
     */
    @Query(nativeQuery = true,value =
            "select TOrganizeCell.FSHORTNAME as 猪场\n" +
            ",ISNULL(sum(pig.母猪后备),0)+ISNULL(sum(pig.空怀),0)+ISNULL(sum(pig.妊娠),0)+ISNULL(sum(pig.哺乳),0) AS 母猪\n" +
            ",ISNULL(sum(pig.公猪后备),0) +ISNULL(sum(pig.成年),0) AS 公猪,ISNULL(sum(pig.教槽),0) AS 仔猪,\n" +
            "ISNULL(sum(pig.保育),0) AS 保育 ,ISNULL(sum(pig.育成),0) +ISNULL(sum(pig.育肥),0) AS 育肥,ISNULL(sum(pig.后备),0) AS 后备\n" +
            ",ISNULL(sum(pig.妊娠),0) AS 妊娠,ISNULL(sum(pig.哺乳),0) AS 哺乳,ISNULL(sum(pig.空怀),0) AS 空怀\n" +
            "from\n" +
            "(select  \n" +
            "       tbl_tmp.猪场id,\n" +
            "       SUM(CASE WHEN tbl_tmp.状态 = '公猪后备' THEN tbl_tmp.数量 ELSE 0 END) AS 公猪后备,\n" +
            "   SUM(CASE WHEN tbl_tmp.状态 = '成年' THEN tbl_tmp.数量 ELSE 0 END) AS 成年, \n" +
            "        SUM(CASE WHEN tbl_tmp.状态 = '母猪后备' THEN tbl_tmp.数量 ELSE 0 END) AS 母猪后备,\n" +
            "        SUM(CASE WHEN tbl_tmp.状态 = '空怀' THEN tbl_tmp.数量 ELSE 0 END) AS 空怀,\n" +
            "        SUM(CASE WHEN tbl_tmp.状态 = '妊娠' THEN tbl_tmp.数量 ELSE 0 END) AS 妊娠, \n" +
            "        SUM(CASE WHEN tbl_tmp.状态 = '哺乳' THEN tbl_tmp.数量 ELSE 0 END) AS 哺乳, \n" +
            "        SUM(CASE WHEN tbl_tmp.状态 = '教槽' THEN tbl_tmp.数量 ELSE 0 END) AS 教槽,\n" +
            "        SUM(CASE WHEN tbl_tmp.状态 = '保育' THEN tbl_tmp.数量 ELSE 0 END) AS 保育, \n" +
            "        SUM(CASE WHEN tbl_tmp.状态 = '育成' THEN tbl_tmp.数量 ELSE 0 END) AS 育成, \n" +
            "        SUM(CASE WHEN tbl_tmp.状态 = '育肥' THEN tbl_tmp.数量 ELSE 0 END) AS 育肥,\n" +
            "         SUM(CASE WHEN tbl_tmp.状态 = '后备' THEN tbl_tmp.数量 ELSE 0 END) AS 后备\n" +
            "   from\n" +
            "(select \n" +
            "case  when TPigArchives.FPigStatee=2  and  TPigArchives.FPigClassEnum =1 then '成年' \n" +
            " when TPigArchives.FPigStatee=11 and  TPigArchives.FPigClassEnum =1 then '公猪后备'   \n" +
            "  when TPigArchives.FPigStatee=14 and  TPigArchives.FPigClassEnum in(1,2) then '保育'  \n" +
            "   when TPigArchives.FPigStatee=15 and  TPigArchives.FPigClassEnum in(1,2) then '教槽'  \n" +
            "           when TPigArchives.FPigStatee=1 and  TPigArchives.FPigClassEnum in(1,2) then '育肥'  \n" +
            "             when TPigArchives.FPigStatee in (4,5) and  TPigArchives.FPigClassEnum =2  then '妊娠'  \n" +
            " when TPigArchives.FPigStatee=6 and  TPigArchives.FPigClassEnum =2  then '哺乳' \n" +
            " when TPigArchives.FPigStatee=11 and  TPigArchives.FPigClassEnum =2 then '母猪后备' \n" +
            " when TPigArchives.FPigStatee in(3,7,10,12,13)and  TPigArchives.FPigClassEnum =2  then '空怀' end as '状态',\n" +
            "count(TPigArchives.FID)  as '数量',\n" +
            "TPigArchives.HOGPENWHEREDID as 猪场id\n" +
            "from TPigArchives \n" +
            "where TPigArchives.FPigClassEnum in(1,2)  and TPigArchives.FPigStatee in(3,7,10,12,13,2,11,14,15,1,4,5,6) \n" +
            "and HOGPENWHEREDID is not null \n" +
            "group by TPigArchives.FPigStatee,TPigArchives.FPigClassEnum ,TPigArchives.HOGPENWHEREDID\n" +
            "union all\n" +
            "       select \n" +
            "      case when TPigArchives.FPigStatee=14 then '保育'  \n" +
            "   when TPigArchives.FPigStatee=15 then '教槽'  \n" +
            "   when TPigArchives.FPigStatee=16 then '育成'  \n" +
            "           when TPigArchives.FPigStatee=1 then '育肥' \n" +
            "           when TPigArchives.FPigStatee=11 then '后备'  end as '状态',\n" +
            " isnull(sum(TPigArchivesChild.FpigAmountOfPigsty),0) as '数量' ,TPigArchives.hogpenwheredID \n" +
            "from TPigArchives \n" +
            "left join  TPigArchivesChild on TPigArchivesChild.FPigArchivesMainStruID=TPigArchives.FID \n" +
            "left join  TFeedStage on TPigArchives.feedingStageEID=TFeedStage.FID \n" +
            "where TPigArchives.FPigClassEnum in(3) \n" +
            "and TFeedStage.fstagename is not null \n" +
            "and FBatchState=0 \n" +
            "and TPigArchives.FPigStatee not in(8,9,17,18) \n" +
            "group by TPigArchives.FPigStatee ,TPigArchives.hogpenwheredID \n" +
            ") as tbl_tmp \n" +
            "    group by tbl_tmp.状态,tbl_tmp.猪场id)pig\n" +
            "    left join TOrganizeCell on pig.猪场id=TOrganizeCell.FID  \n" +
            "group by pig.猪场id,TOrganizeCell.FSHORTNAME order by  TOrganizeCell.FSHORTNAME")
    List<Object[]> getManyFarmStock();

    /**
     * @Method      : getManyFarmProduce
     * @Description : 
     * @Params      : [startDate, endDate]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/11/16       
     * @Time        : 18:37
     */
    @Query(nativeQuery = true,value ="select TOrganizeCell.FNAME, (SELECT  CASE WHEN DATEDIFF ( dd ,       ?1 ,    ?2 ) >=31  THEN \n" +
            "case when ISNULL(cszrjcl.出生合格仔,0)!=0 then 1-(isnull(die.教槽,0)+isnull(lose.教槽,0))/cszrjcl.出生合格仔 else 0 end ELSE \n" +
            "case when isnull(clqc.仔猪日均存栏,0)+isnull(clbd.仔猪日均存栏,0) !=0\n" +
            "then 1-(isnull(die.教槽,0)+isnull(lose.教槽,0))/(isnull(clqc.仔猪日均存栏,0)+isnull(clbd.仔猪日均存栏,0) ) else 0 end END )AS '产房成活率',\n" +
            "  (SELECT  CASE WHEN DATEDIFF ( dd ,       ?1 ,    ?2 ) >=31  THEN \n" +
            "case when isnull(spzyz.商品猪引种保育头数,0)+isnull(tmp_tblzz.仔猪断奶头数,0)>0 then 1-(isnull(die.保育,0)+isnull(lose.保育,0))/(isnull(spzyz.商品猪引种保育头数,0)+isnull(tmp_tblzz.仔猪断奶头数,0)) else 0 end ELSE \n" +
            "case when isnull(clqc.保育日均存栏,0)+isnull(clbd.保育日均存栏,0) !=0\n" +
            "then 1-(isnull(die.保育,0)+isnull(lose.保育,0))/(isnull(clqc.保育日均存栏,0)+isnull(clbd.保育日均存栏,0))else 0 end END )AS '保育成活率',\n" +
            "   (SELECT  CASE WHEN DATEDIFF ( dd ,       ?1 ,    ?2 ) >=31  THEN \n" +
            "case when isnull(spzyz.商品猪引种育肥头数,0)+isnull(tmp_tblbyz.ZYFZTS,0)>0 then 1-(isnull(die.育肥,0)+isnull(lose.育肥,0))/(isnull(spzyz.商品猪引种育肥头数,0)+isnull(tmp_tblbyz.ZYFZTS,0)) else 0 end ELSE \n" +
            "case when isnull(clqc.育肥日均存栏,0)+isnull(clbd.育肥日均存栏,0) !=0\n" +
            "then 1-(   isnull(die.育肥,0)+isnull(lose.育肥,0))/(   isnull(clqc.育肥日均存栏,0)+isnull(clbd.育肥日均存栏,0))else 0 end END )AS '肥猪成活率'\n" +
            " ,isnull(tmp_tblfm.PJWCZZ,0) as '平均窝产仔猪', isnull(tmp_tblfm.PJWCHZ,0) as '平均窝产活仔数', isnull(tmp_tblfm.PJWCZC,0) as '平均窝产正常仔数',isnull(tmp_tbldn.PJWDNTS,0) as '窝断奶仔猪数'\n" +
            " ,isnull(tmp_tbldn.PJDNWZ,0) as '平均断奶窝重',isnull(dn3.DPL,0) as '7日断配率',NCWS.NLYWS as '年产窝数'\n" +
            "from  \n" +
            " ( \n" +
            "    select TStockHistory.hogpenDID as 'ZCID', sum(TStockHistory.FAmountChangeInt) as 'ZCL', \n" +
            "      sum(case when TStockHistory.FPigStatee in(3,4,5,6,7,12,13) and TStockHistory.FPigClassE=2 then isnull(TStockHistory.FAmountChangeInt,0)end)  as '母猪日均存栏', \n" +
            "      sum(case when TStockHistory.FPigStatee in(3,7,12,13,5,6,2,11) and TStockHistory.FPigClassE in(1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '种猪日均存栏', \n" +
            "      sum(case when TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '后备日均存栏', \n" +
            "      sum(case when TStockHistory.FPigStatee in(15) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '仔猪日均存栏', \n" +
            "      sum(case when TStockHistory.FPigStatee in(14) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '保育日均存栏', \n" +
            "      sum(case when (TStockHistory.FPigStatee in(1,22,21,16) or TStockHistory.FPigStatee is null) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '育肥日均存栏', \n" +
            "      sum(case when  TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE=3 then isnull(TStockHistory.FAmountChangeInt,0)end)  as '后备商日均存栏' \n" +
            "    from TStockHistory \n" +
            "      where  datediff(dd,      ?1, TStockHistory.FdateChange)<0  \n" +
            "                  and TStockHistory.FPigClassE in(1,2,3) \n" +
            "    group by TStockHistory.hogpenDID)clqc \n" +
            "   left join (select tmp_tblcl.ZCID as 'ZCID',round(avg(isnull(tmp_tblcl.ZCL,0)*1.00000),0) as 'ZCL',round(avg(isnull(tmp_tblcl.母猪日均存栏,0)*1.00000),0) as '母猪日均存栏'\n" +
            " ,round(avg(isnull(tmp_tblcl.种猪日均存栏,0)*1.00000),0) as '种猪日均存栏'\n" +
            "  ,round(avg(isnull(tmp_tblcl.后备日均存栏,0)*1.00000),0) as '后备日均存栏',round(avg(isnull(tmp_tblcl.仔猪日均存栏,0)*1.00000),0) as '仔猪日均存栏'\n" +
            "  ,round(avg(isnull(tmp_tblcl.保育日均存栏,0)*1.00000),0) as '保育日均存栏',round(avg(isnull(tmp_tblcl.育肥日均存栏,0)*1.00000),0) as '育肥日均存栏'\n" +
            "  ,round(avg(isnull(tmp_tblcl.后备商品猪日均存栏,0)*1.00000),0) as '后备商日均存栏'\n" +
            "    from(  \n" +
            "    select TStockHistory.hogpenDID as 'ZCID', sum(TStockHistory.FAmountChangeInt) as 'ZCL', \n" +
            "      sum(case when TStockHistory.FPigStatee in(3,4,5,6,7,12,13) and TStockHistory.FPigClassE=2 then isnull(TStockHistory.FAmountChangeInt,0)end)  as '母猪日均存栏', \n" +
            "      sum(case when TStockHistory.FPigStatee in(3,7,12,13,5,6,2,11) and TStockHistory.FPigClassE in(1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '种猪日均存栏', \n" +
            "      sum(case when TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '后备日均存栏', \n" +
            "      sum(case when TStockHistory.FPigStatee in(15) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '仔猪日均存栏', \n" +
            "      sum(case when TStockHistory.FPigStatee in(14) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '保育日均存栏', \n" +
            "      sum(case when (TStockHistory.FPigStatee in(1,22,21,16) or TStockHistory.FPigStatee is null) and TStockHistory.FPigClassE in (1,2,3) then isnull(TStockHistory.FAmountChangeInt,0)end)  as '育肥日均存栏', \n" +
            "      sum(case when  TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE=3 then isnull(TStockHistory.FAmountChangeInt,0)end)  as '后备商品猪日均存栏' \n" +
            "   ,qj.time as billdate\n" +
            "    from TStockHistory \n" +
            "            left join ( select   CONVERT(varchar(10), CONVERT(datetime,       ?1)+d,120) as  [time] \n" +
            "                from\n" +
            "                (\n" +
            "                    select   top   (datediff(day,      ?1,   ?2)+1)   row_number()   \n" +
            "                    over(order   by   getdate())-1   d   from   sys.objects\n" +
            "                ) as a) qj on 1=1\n" +
            "                where TStockHistory.FdateChange<=qj.time\n" +
            "          and  datediff(dd,      ?1, TStockHistory.FdateChange)>=0  \n" +
            "                  and TStockHistory.FPigClassE in(1,2,3) \n" +
            "    group by TStockHistory.hogpenDID,qj.time ) tmp_tblcl\n" +
            "   group by tmp_tblcl.ZCID)clbd on clqc.ZCID =clbd.ZCID\n" +
            "left join (   select temp.PigHouseID,sum(isnull(temp.育肥,0)) as 育肥,sum(isnull(temp.教槽,0)) as 教槽,sum(isnull(temp.保育,0)) as 保育,\n" +
            "    sum(isnull(temp.基础母,0)) as 基础母,sum(isnull(temp.基础公,0)) as 基础公,sum(isnull(temp.后备公,0))as 后备公\n" +
            "  ,sum(isnull(temp.后备母,0))as 后备母,sum(isnull(temp.后备,0)) as 后备商\n" +
            "    from\n" +
            "  (select TPigDie.PigHouseID   ,\n" +
            "      case when TPigDieChild.FPigState in(1,21,22,16) and TPigDieChild.FPigSex IN(1,2,3) then  sum(TPigDieChild.FweakpigdieCount)+sum(TPigDieChild.Fpigdiecount)  end '育肥' ,\n" +
            "      case   when TPigDieChild.FPigState in(15) and TPigDieChild.FPigSex IN(1,2,3) then sum(TPigDieChild.FweakpigdieCount)+sum(TPigDieChild.Fpigdiecount)  end'教槽' ,\n" +
            "      case   when TPigDieChild.FPigState in(14) and TPigDieChild.FPigSex IN(1,2,3) then  sum(TPigDieChild.FweakpigdieCount)+sum(TPigDieChild.Fpigdiecount)end '保育' ,\n" +
            "      case   when TPigDieChild.FPigState in(11) and TPigDieChild.FPigSex=3 then sum(TPigDieChild.FweakpigdieCount)+sum(TPigDieChild.Fpigdiecount)  end  '后备'\n" +
            "             , case when TPigDieChild.FPigState in(3,7,12,13,5,6) and TPigDieChild.FPigSex=2 \n" +
            "              then  count(TPigDieChild.FID) end'基础母' \n" +
            "              , case when TPigDieChild.FPigState in(2) and TPigDieChild.FPigSex=1\n" +
            "              then  count(TPigDieChild.FID) end'基础公' \n" +
            "                 , case when TPigDieChild.FPigState =11 and TPigDieChild.FPigSex=1\n" +
            "              then  count(TPigDieChild.FID) end'后备公' \n" +
            "              , case when TPigDieChild.FPIGSTATE=11 and TPigDieChild.FPigSex=2\n" +
            "              then  count(TPigDieChild.FID) end'后备母' \n" +
            "     from TPigDie \n" +
            "      left join TPigDieChild on TPigDieChild.FPigDieMainStruID=TPigDie.FID   \n" +
            "     where TPigDie.FBillState in(3,4,6) and TPigDieChild.FPigSex in(1,2,3) and FPIGSTATE in (14,15,1,21,22,11,2,3,7,12,13,5,6,16)\n" +
            "     and ( datediff(dd,      ?1, TPigDie.FDieDate)>=0 and datediff(dd,   ?2,TPigDie.FDieDate) <=0) \n" +
            "     group by TPigDieChild.FPigState,TPigDieChild.FPigSex ,TPigDie.PigHouseID  )temp\n" +
            "     group by temp.PigHouseID\n" +
            "   ) die on die.PigHouseID=clqc.ZCID \n" +
            "   \n" +
            "left join (     select temp.PigHouseID,sum(isnull(temp.淘汰商,0)) as 淘汰商,sum(isnull(temp.淘汰母,0)) as 淘汰母,sum(isnull(temp.淘汰公,0)) as 淘汰公\n" +
            ",sum(isnull(temp.淘汰后备,0)) as 淘汰后备,sum(isnull(temp.育肥,0)) as 育肥,sum(isnull(temp.教槽,0)) as 教槽,sum(isnull(temp.保育,0)) as 保育 \n" +
            "    from\n" +
            "  (select TPigLose.PigHouseID   ,\n" +
            "       case   when TPigLoseChild.FSEX=3  and FPIGSTATE!=11\n" +
            "      then sum(TPigLoseChild.FpigLoseCount)+sum(TPigLoseChild.FweakPigLoseCount)  end  '淘汰商'\n" +
            "             , case when TPigLoseChild.FSEX=2 and FPIGSTATE!=11  then  count(TPigLoseChild.FID) end '淘汰母' \n" +
            "              , case when TPigLoseChild.FSEX=1 and FPIGSTATE!=11 then  count(TPigLoseChild.FID) end '淘汰公' \n" +
            "               , case when TPigLoseChild.FSEX in(1,2,3) and FPIGSTATE=11 then  count(TPigLoseChild.FID) end '淘汰后备' \n" +
            "               ,case when TPigLoseChild.FPigState in(1,21,22,16) and TPigLoseChild.FSEX IN(1,2,3) then \n" +
            "                sum(TPigLoseChild.FpigLoseCount)+sum(TPigLoseChild.FweakPigLoseCount)  end '育肥' ,\n" +
            "                case   when TPigLoseChild.FPigState in(15) and TPigLoseChild.FSEX IN(1,2,3) then sum(TPigLoseChild.FpigLoseCount)+sum(TPigLoseChild.FweakPigLoseCount)  end'教槽' ,\n" +
            "                case   when TPigLoseChild.FPigState in(14) and TPigLoseChild.FSEX IN(1,2,3) then  sum(TPigLoseChild.FpigLoseCount)+sum(TPigLoseChild.FweakPigLoseCount)end '保育' \n" +
            "     from TPigLose left join TPigLoseChild on TPigLoseChild.FPigLoseMainStruID=TPigLose.FID   \n" +
            "     where TPigLose.FBillState in(3,4,6) and TPigLoseChild.FSEX in(1,2,3) and FPIGSTATE in (14,15,1,21,22,11,2,3,7,12,13,5,6,16)\n" +
            "      and (datediff(dd,      ?1, TPigLose.Fpiglosedate )>=0 and datediff(dd,   ?2,TPigLose.Fpiglosedate ) <=0) \n" +
            "     group by TPigLoseChild.FPigState,TPigLoseChild.FSEX ,TPigLose.PigHouseID  )temp\n" +
            "     group by temp.PigHouseID\n" +
            "   ) lose on lose.PigHouseID=clqc.ZCID \n" +
            "left join \n" +
            "          (select TBorn.HOGPENDID as 'ZCID',count(TBornNewStru.FID) as '出生合格仔',SUM(TBornNewStru.FWEIGHTINT) as '出生重'\n" +
            "           from TBorn left join TBornNewStru on TBornNewStru.FBornMainStruID = TBorn.FID \n" +
            "                                 \n" +
            "           where TBorn.FLOGSTATEE in (3,4,6)  \n" +
            "             and  datediff(dd,      ?1,TBorn.FDATEBORN)>=0 and datediff(dd,   ?2,TBorn.FDATEBORN) <=0\n" +
            "             group by TBorn.HOGPENDID\n" +
            "            )cszrjcl on cszrjcl.ZCID=clqc.ZCID \n" +
            "            \n" +
            "     left join (select zz.ZCID as 'ZCID',SUM(zz.商品猪引种保育头数) as '商品猪引种保育头数',SUM(zz.商品猪引种育肥头数) as '商品猪引种育肥头数'\n" +
            "      ,SUM(zz.保育引种重量) as '保育引种重量',SUM(zz.育肥引种重量) as '育肥引种重量',SUM(zz.后备引种重量) as '后备引种重量',SUM(zz.brbyyf引种重量) as 'brbyyf引种重量' from\n" +
            "(select TBoarStock.STOCKORGID as 'ZCID',\n" +
            "     case when  TBoarStockChild.FPIGSTATE = 14 then  SUM(FNORMALAMOUNT)+SUM (FWEAKAMOUNT) end as '商品猪引种保育头数',\n" +
            "     case when  TBoarStockChild.FPIGSTATE = 1 then  SUM(FNORMALAMOUNT)+SUM (FWEAKAMOUNT) end as '商品猪引种育肥头数',\n" +
            "      case when  TBoarStockChild.FPIGSTATE = 14 then SUM(FALLWEIGHT) end AS '保育引种重量', \n" +
            "       case when  TBoarStockChild.FPIGSTATE = 1 then SUM(FALLWEIGHT) end AS '育肥引种重量',\n" +
            "        case when  TBoarStockChild.FPIGSTATE = 11 then SUM(FALLWEIGHT) end AS '后备引种重量',\n" +
            "           case when  TBoarStockChild.FPIGSTATE IN(15,14,1) then SUM(FALLWEIGHT) end AS 'brbyyf引种重量'\n" +
            "      from TBoarStockChild left join TBoarStock on TBoarStockChild.FBoarStockMainStruID = TBoarStock.FID \n" +
            "    where TBoarStock.FBILLSTATE in (3,4,6,12) and TBoarStock.FINTRODUCTIONCLASS =3 \n" +
            "    and  datediff(dd,      ?1, TBoarStock.FINHOGPENDATE)>=0 and datediff(dd,   ?2,TBoarStock.FINHOGPENDATE) <=0\n" +
            "     group by TBoarStock.STOCKORGID,TBoarStockChild.FPIGSTATE) zz group by zz.ZCID\n" +
            "     )spzyz on spzyz.ZCID = clqc.ZCID \n" +
            "        left join (select TWeaningPiglets.hogpenDID as 'ZCID', \n" +
            "     sum(TWeaningPigletsNewStru.FweightSum)*1.0/(case sum(TWeaningPigletsNewStru.FAmountHead) when 0 then null else sum(TWeaningPigletsNewStru.FAmountHead) end) as 'ZZPJDNTZ', \n" +
            "    sum(TWeaningPigletsNewStru.FAmountHead) as '仔猪断奶头数',sum(TWeaningPigletsNewStru.FweightSum) as '断奶总重'\n" +
            "    from TWeaningPiglets left join TWeaningPigletsNewStru on TWeaningPigletsNewStru.FWeaningPigletsMainStruID=TWeaningPiglets.FID \n" +
            "  \n" +
            "    where TWeaningPiglets.FlogStateE in(3,4,6,12) and  datediff(dd,      ?1, TWeaningPiglets.FdateWeaning)>=0 and datediff(dd,   ?2,TWeaningPiglets.FdateWeaning) <=0 \n" +
            "    group by TWeaningPiglets.hogpenDID)tmp_tblzz on tmp_tblzz.ZCID=clqc.ZCID \n" +
            "     left join (select tmp_tblzs.ZCID as 'ZCID', sum(tmp_tblzs.ZYFPJTZ*tmp_tblzs.ZYFZTS)/(case sum(tmp_tblzs.ZYFZTS) when 0 then null else sum(tmp_tblzs.ZYFZTS) end) as 'ZYFPJTZ', \n" +
            " \n" +
            "   SUM(tmp_tblzs.ZYFZTS) as 'ZYFZTS' ,sum(tmp_tblzs.ZYFPJTZ*tmp_tblzs.ZYFZTS) as '保育转育肥重量'\n" +
            "    from(select TPiginout.inpighogpenID as 'ZCID', TPiginoutChild.Favgweight as 'ZYFPJTZ', TPiginoutChild.FToHomeSfew as 'ZYFZTS'\n" +
            "   \n" +
            "     from TPiginout left join TPiginoutChild on TPiginoutChild.FPiginoutMainStruID=TPiginout.FID\n" +
            "   \n" +
            "     where TPiginout.FBillFormState in(3,4,6,12) and TPiginoutChild.FPigCalss=3 and TPiginout.FpigpPhase=1 and  datediff(dd,      ?1, TPiginout.Finouthousedata)>=0 and datediff(dd,   ?2,TPiginout.Finouthousedata) <=0 \n" +
            "  )tmp_tblzs group by tmp_tblzs.ZCID )tmp_tblbyz on tmp_tblbyz.ZCID=clqc.ZCID \n" +
            "  \n" +
            "    left join (select TDelivery.HogpendID as 'ZCID',count(TNewStru7743.FID) as 'CZWS',avg(TNewStru7743.FamountLiveInt*1.0) as 'PJWCHZ' \n" +
            "  ,avg(TNewStru7743.FAMOUNTKITTENINT*1.0) as 'PJWCZZ' ,avg(TNewStru7743.FAMOUNTRIGHTINT*1.0) as 'PJWCZC' ,sum(TNewStru7743.FAMOUNTRIGHTINT*1.0+TNewStru7743.FAMOUNTPUNINESSINT) as 'WCHZ' \n" +
            "  ,sum(TNewStru7743.FAMOUNTKITTENINT*1.0) as 'WCZZ' \n" +
            "    from TDelivery left join TNewStru7743 on TNewStru7743.FDeliveryMainStruID=TDelivery.FID \n" +
            "    where TDelivery.FLogStatee in(3,4,6) and  datediff(dd,      ?1, TDelivery.FDateDelivery)>=0 and datediff(dd,   ?2,TDelivery.FDateDelivery) <=0 \n" +
            "    group by TDelivery.HogpendID )tmp_tblfm on tmp_tblfm.ZCID=clqc.ZCID \n" +
            "    left join (select TWeaning.HogpendID as 'ZCID', count(TWeaningNewStru.FID)'DNMZS',sum(TWeaningNewStru.FAmountWeanInt)'DNZZS', \n" +
            "     sum(TWeaningNewStru.FweightInt)*1.0/count(TWeaningNewStru.FID) as 'PJDNWZ', \n" +
            "     sum(TWeaningNewStru.FAmountWeanInt)*1.0/count(TWeaningNewStru.FID) as 'PJWDNTS'\n" +
            "    from TWeaning left join TWeaningNewStru on TWeaningNewStru.FWeaningMainStruID=TWeaning.FID\n" +
            "    where TWeaning.FLogStatee in(3,4,6) and  datediff(dd,      ?1, TWeaning.FdateWeaning)>=0 and datediff(dd,   ?2,TWeaning.FdateWeaning) <=0 \n" +
            "    group by TWeaning.HogpendID )tmp_tbldn on tmp_tbldn.ZCID=clqc.ZCID \n" +
            "      left join \n" +
            "(select tmp_tbl.HOGPENDID, CAST(count(tmp_tbl.发情ID)*1.0/case(count(tmp_tbl.断奶ID) -COUNT(tmp_tbl.stid)) when 0 then null else (count(tmp_tbl.断奶ID) -COUNT(tmp_tbl.stid))  end as dec(8,5))as 'DPL'\n" +
            " from (select TWeaningNewStru.FBreedD as '品种',TWeaning.HOGPENDID, \n" +
            " subString(convert(varchar(7),TWeaning.FDateWeaning,120),1,4)+'年'+subString(convert(varchar(7),\n" +
            " TWeaning.FDateWeaning,120),6,2)+'月份' as '月', TWeaningNewStru.FID as '断奶ID', tmp_tblfq.SowStrID as '发情ID' ,\n" +
            "st.NUMBERID as stid \n" +
            " from TWeaning left join TWeaningNewStru on TWeaningNewStru.FWeaningMainStruID=TWeaning.FID \n" +
            " left join (   select SowStrID,FParityInt,FDATEBREED from TBreeding left join TNewStru8094 \n" +
            " on TNewStru8094.FBreedingMainStruID=TBreeding.FID where TBreeding.FLogStatee in(3,4,6)) tmp_tblfq \n" +
            " on tmp_tblfq.SowStrID=TWeaningNewStru.SowStrID and tmp_tblfq.FParityInt=TWeaningNewStru.FParityInt \n" +
            " and tmp_tblfq.FDATEBREED<=TWeaning.FDateWeaning+7 and tmp_tblfq.FDATEBREED>=TWeaning.FDateWeaning\n" +
            "left join(select NUMBERID,FDIEDATE as stdate from TPigDie \n" +
            "   left join TPigDieChild on TPigDieChild.FPigDieMainStruID=TPigDie.FID where TPigDie.FBillState in(3,4,6)\n" +
            "   and TPigDieChild.FPIGSTATE!=5\n" +
            "   union all\n" +
            "   select  NUMBERID,FPIGLOSEDATE as stdate from TPigLose \n" +
            "   left join TPigLoseChild on TPigLoseChild.FPigLoseMainStruID=TPigLose.FID \n" +
            "   and TPigLoseChild.FPIGSTATE!=5\n" +
            "  where TPigLose.FBillState in(3,4,6) \n" +
            "  ) st \n" +
            " on   st.NUMBERID=TWeaningNewStru.SowStrID \n" +
            " and st.stdate<=TWeaning.FDateWeaning+7 and st.stdate>=TWeaning.FDateWeaning  \n" +
            " where TWeaning.FLogStatee in(3,4,6)\n" +
            " and  datediff(dd,      ?1, TWeaning.FdateWeaning)>=-7 and datediff(dd,   ?2,TWeaning.FdateWeaning) <=-7   \n" +
            "  ) tmp_tbl \n" +
            "   group by tmp_tbl.HOGPENDID)dn3 on dn3.HogpendID=clqc.ZCID \n" +
            "   left join (select  CAST(365*1.0/avg(tjj) as dec(7,4)) as 'NLYWS' ,ZCID\n" +
            "  from\n" +
            "    (SELECT  \n" +
            "   case when isnull(TNewStru7743.FtyreDistance,0)!=0 then  TNewStru7743.FtyreDistance else DATEDIFF(dd,TPigArchives.FDATEOFBIRTH,TDelivery.FDATEDELIVERY)-250 end  as 'tjj' \n" +
            "   ,TDelivery.HOGPENDID  as ZCID\n" +
            "      FROM TDelivery    \n" +
            "   LEFT JOIN TNewStru7743  on TNewStru7743.FDeliveryMainStruID = TDelivery.FID \n" +
            "     left join  TPigArchives on TNewStru7743.SOWSTRID = TPigArchives.FID\n" +
            "    WHERE  TDelivery.FlogStateE in(3,4,6)\n" +
            "     And ( datediff(dd,      ?1,TDelivery.FDATEDELIVERY)>=0 or       ?1 is null) \n" +
            "     And (datediff(dd,   ?2,TDelivery.FDATEDELIVERY)<=0 or    ?2 is null) \n" +
            "   ) tmp_tbl   \n" +
            "     group by tmp_tbl.ZCID\n" +
            "      having avg(tjj)>0)NCWS on  clqc.ZCID=NCWS.ZCID\n" +
            "     left join TOrganizeCell on clqc.ZCID=TOrganizeCell.FID where FNAME  is not null")
    List<Object[]> getManyFarmProduce(Date startDate, Date endDate);

    /**
     * @Method      : getWarningMessage
     * @Description : 读取预警信息
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/11/19       
     * @Time        : 15:45
     */
    @Query(nativeQuery = true,value ="SELECT  TML.FMESSAGESTR AS '消息内容', TML.FDATETIPS AS '提示日期'\n" +
            "  FROM TMessageLog AS TML,TMessageAndUserData AS TAUD  ,TWarnigRules AS TWR WHERE  TWR.FID = TML.WARNINGRULESDID \n" +
            "  AND  TAUD.FISTREATMENTE =0 AND TML.FID= TAUD.MESSAGELOGDID  and DATEDIFF(day,TML.FDATETIPS,getDate())<=?1 \n" +
            "   group by TML.FMESSAGESTR, TML.FDATETIPS\n" +
            "   ORDER BY TML.FDATETIPS")
    List<Object[]> getWarningMessage(Integer days);

    /**
     * @Method      : getWorkPlan
     * @Description : 
     * @Params      : [startDate, endDate]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/11/22       
     * @Time        : 16:05
     */
    @Query(nativeQuery = true,value ="select TOrganizeCell.FName , tbl.计划类型,count(DISTINCT(tbl.计划名称)) as '计划数',SUM(tbl.猪只数量) as '猪只头数'\n" +
            "from(  " +
            "select " +
            "TPigArchives.hogpenWhereDID,TPigArchives.homesNoDID,TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',1 as '猪只数量',CASE WHEN TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' WHEN TplanScheme.FplanType=5 THEN '普免计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            "TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,case when TplanScheme.FcountType=0 then fplanDate else dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth) end  as '计划时间', TPigArchives.FPARITYINT  as '胎次',FDAYAGE\n" +
            "from TplanScheme, TPlanSchemeChild ,TPigArchives \n" +
            "where  TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID  and TPigArchives.FPigClassEnum in(1,2) and TPigArchives.FPIGSTATEE not in(8,9,18,17) \n" +
            "and( (TplanScheme.FcountType=1 and TPigArchives.FdayAge<=TplanScheme.Fdays and dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth)>=?1\n" +
            "and dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth)<=?2  and (TplanScheme.FPIGSTATE=0 or TPigArchives.FPIGSTATEE=TplanScheme.FPIGSTATE)) \n" +
            "or(TplanScheme.FcountType=0 and fplanDate>=?1 and fplanDate<=?2 ))\n" +
            "and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) \n" +
            "and (TPigArchives.FPARITYINT between TplanScheme.FPARITYFIRST and TplanScheme.FPARITYLAST)\t\t\t\n" +
            "  union all \n" +
            " select \n" +
            " TPigArchives.hogpenWhereDID,TPigArchivesChild.PigStyID as 'homesNoDID',TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',TPigArchivesChild.fpigamountofpigsty as '猪只数量',CASE WHEN TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' WHEN TplanScheme.FplanType=5 THEN '普免计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            " TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,case when TplanScheme.FcountType=0 then fplanDate else dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth) end  as '计划时间',TPigArchives.FPARITYINT as '胎次',FDAYAGE \n" +
            " from TplanScheme, TPlanSchemeChild ,TPigArchives \n" +
            " ,TPigArchivesChild  \n" +
            " where TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID  \n" +
            " and TPigArchivesChild.FPigArchivesMainStruID=TPigArchives.FID and TPigArchives.FbatchState=0 and TPigArchives.FPigClassEnum=3 and TPigArchives.FPIGSTATEE not in(8,9,18,17) \n" +
            " and (TplanScheme.FcountType=1 and TPigArchives.FdayAge<=TplanScheme.Fdays and dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth)>=?1 and dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth)<=?2   and (TplanScheme.FPIGSTATE=0 or TPigArchives.FPIGSTATEE=TplanScheme.FPIGSTATE)) \n" +
            " and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) "+
            "union all \n" +
            "select \n" +
            "TPigArchives.hogpenWhereDID,TPigArchives.homesNoDID,TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',1 as '猪只数量',CASE WHEN TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            "TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ) as '计划时间' ,TPigArchives.FPARITYINT as '胎次',FDAYAGE\n" +
            "from TplanScheme \n" +
            "left join TPlanSchemeChild on TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID \n" +
            "left join (select TNewStru8094.sowStrID, max(TBreeding.FdateBreed) as 'YWRQ' from TBreeding \n" +
            "left join TNewStru8094 on TBreeding.FID=TNewStru8094.FBreedingMainStruID \n" +
            "where TBreeding.FlogStateE in (3,4,6,12) group by TNewStru8094.sowStrID ) tmp_tbl on datediff(dd,tmp_tbl.YWRQ,getdate())<=TplanScheme.Fdays \n" +
            "left join TPigArchives on tmp_tbl.sowStrID=TPigArchives.FID \n" +
            "where TplanScheme.FcountType=2 and TPigArchives.FPIGSTATEE not in(8,9,18,17,7,12,13) \n" +
            "and (dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)>=?1 and dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)<=?2) \n" +
            "and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) \n" +
            "and (TPigArchives.FPARITYINT between TplanScheme.FPARITYFIRST and TplanScheme.FPARITYLAST)\n" +
            "union all \n" +
            "select \n" +
            "TPigArchives.hogpenWhereDID,TPigArchives.homesNoDID,TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',1 as '猪只数量',CASE WHEN TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            "TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ) as '计划时间' ,TPigArchives.FPARITYINT as '胎次',FDAYAGE\n" +
            "from TplanScheme \n" +
            "left join TPlanSchemeChild on TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID \n" +
            "left join (select TNewStru7743.sowStrID, max(TDelivery.FdateDelivery) as 'YWRQ' from TDelivery \n" +
            "left join TNewStru7743 on TDelivery.FID=TNewStru7743.FDeliveryMainStruID \n" +
            "where TDelivery.FlogStateE in (3,4,6,12) group by TNewStru7743.sowStrID ) tmp_tbl on datediff(dd,tmp_tbl.YWRQ,getdate())<=TplanScheme.Fdays \n" +
            "left join TPigArchives on tmp_tbl.sowStrID=TPigArchives.FID \n" +
            "where TplanScheme.FcountType=3 and TPigArchives.FPIGSTATEE not in(8,9,18,17,7,12,13) \n" +
            "and (dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)>=?1 and dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)<=?2) \n" +
            "and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) \n" +
            "and (TPigArchives.FPARITYINT between TplanScheme.FPARITYFIRST and TplanScheme.FPARITYLAST)\n" +
            "union all  \n" +
            "select \n" +
            "TPigArchives.hogpenWhereDID,TPigArchives.homesNoDID,TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',1 as '猪只数量',CASE WHEN  TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            "TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ) as '计划时间' ,TPigArchives.FPARITYINT as '胎次',FDAYAGE\n" +
            "from TplanScheme \n" +
            "left join TPlanSchemeChild on TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID \n" +
            "left join (select TWeaningNewStru.sowStrID, max(TWeaning.FdateWeaning) as 'YWRQ' from TWeaning \n" +
            "left join TWeaningNewStru on TWeaning.FID=TWeaningNewStru.FWeaningMainStruID \n" +
            "where TWeaning.FlogStateE in (3,4,6,12) group by TWeaningNewStru.sowStrID ) tmp_tbl on datediff(dd,tmp_tbl.YWRQ,getdate())<=TplanScheme.Fdays \n" +
            "left join TPigArchives on tmp_tbl.sowStrID=TPigArchives.FID  \n" +
            "where TplanScheme.FcountType=4 and TPigArchives.FPIGSTATEE not in(8,9,18,17) \n" +
            "and (dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)>=?1 and dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)<=?2 ) \t\t\t\n" +
            "and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) \n" +
            "and (TPigArchives.FPARITYINT between TplanScheme.FPARITYFIRST and TplanScheme.FPARITYLAST)"+
            ")tbl \n" +
            "left join TPigHouse on tbl.homesNoDID=TPigHouse.FID \n" +
            "left join TOrganizeCell on tbl.hogpenWhereDID=TOrganizeCell.FID \n" +
            "left join TPigArchives on tbl.猪只编码 = TPigArchives.FNUMBER\n" +
            "where tbl.计划时间 >= getDate() \n" +
            "group by tbl.计划类型\n")
    List<Object[]> getWorkPlan(Date startDate,Date endDate);

    @Query(nativeQuery = true,value ="select TOrganizeCell.FName ,tbl.计划类型,count(DISTINCT(tbl.计划名称)) as '计划数',SUM(tbl.猪只数量) as '猪只头数'\n" +
            "from(  \n" +
            "select \n" +
            "TPigArchives.hogpenWhereDID,TPigArchives.homesNoDID,TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',1 as '猪只数量',CASE WHEN TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' WHEN TplanScheme.FplanType=5 THEN '普免计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            "TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,case when TplanScheme.FcountType=0 then fplanDate else dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth) end  as '计划时间', TPigArchives.FPARITYINT  as '胎次',FDAYAGE\n" +
            "from TplanScheme, TPlanSchemeChild ,TPigArchives \n" +
            "where  TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID  and TPigArchives.FPigClassEnum in(1,2) and TPigArchives.FPIGSTATEE not in(8,9,18,17) \n" +
            "and( (TplanScheme.FcountType=1 and TPigArchives.FdayAge<=TplanScheme.Fdays and dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth)>=?1\n" +
            "and dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth)<=?2  and (TplanScheme.FPIGSTATE=0 or TPigArchives.FPIGSTATEE=TplanScheme.FPIGSTATE)) \n" +
            "or(TplanScheme.FcountType=0 and fplanDate>=?1 and fplanDate<=?2 ))\n" +
            "and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) \n" +
            "and (TPigArchives.FPARITYINT between TplanScheme.FPARITYFIRST and TplanScheme.FPARITYLAST)\n" +
            "union all \n" +
            "select \n" +
            "TPigArchives.hogpenWhereDID,TPigArchivesChild.PigStyID as 'homesNoDID',TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',TPigArchivesChild.fpigamountofpigsty as '猪只数量',CASE WHEN TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' WHEN TplanScheme.FplanType=5 THEN '普免计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            "TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,case when TplanScheme.FcountType=0 then fplanDate else dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth) end  as '计划时间',TPigArchives.FPARITYINT as '胎次',FDAYAGE \n" +
            "from TplanScheme, TPlanSchemeChild ,TPigArchives ,TPigArchivesChild  \n" +
            "where TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID  \n" +
            "and TPigArchivesChild.FPigArchivesMainStruID=TPigArchives.FID and TPigArchives.FbatchState=0 and TPigArchives.FPigClassEnum=3 and TPigArchives.FPIGSTATEE not in(8,9,18,17) \n" +
            "and (TplanScheme.FcountType=1 and TPigArchives.FdayAge<=TplanScheme.Fdays and dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth)>=?1 and dateadd(dd,TplanScheme.Fdays,TPigArchives.FdateOfBirth)<=?2   and (TplanScheme.FPIGSTATE=0 or TPigArchives.FPIGSTATEE=TplanScheme.FPIGSTATE)) \t\t\t\n" +
            "and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) \n" +
            "union all \n" +
            "select \n" +
            "TPigArchives.hogpenWhereDID,TPigArchives.homesNoDID,TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',1 as '猪只数量',CASE WHEN TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            "TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ) as '计划时间' ,TPigArchives.FPARITYINT as '胎次',FDAYAGE\n" +
            "from TplanScheme \n" +
            "left join TPlanSchemeChild on TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID \n" +
            "left join (select TNewStru8094.sowStrID, max(TBreeding.FdateBreed) as 'YWRQ' from TBreeding \n" +
            "left join TNewStru8094 on TBreeding.FID=TNewStru8094.FBreedingMainStruID \n" +
            "where TBreeding.FlogStateE in (3,4,6,12) group by TNewStru8094.sowStrID ) tmp_tbl on datediff(dd,tmp_tbl.YWRQ,getdate())<=TplanScheme.Fdays \n" +
            "left join TPigArchives on tmp_tbl.sowStrID=TPigArchives.FID \n" +
            "where TplanScheme.FcountType=2 and TPigArchives.FPIGSTATEE not in(8,9,18,17,7,12,13) \n" +
            "and (dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)>=?1 and dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)<=?2) \t\n" +
            "and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) \n" +
            "and (TPigArchives.FPARITYINT between TplanScheme.FPARITYFIRST and TplanScheme.FPARITYLAST)\n" +
            "union all \n" +
            "select \n" +
            "TPigArchives.hogpenWhereDID,TPigArchives.homesNoDID,TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',1 as '猪只数量',CASE WHEN TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            "TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ) as '计划时间' ,TPigArchives.FPARITYINT as '胎次',FDAYAGE\n" +
            "from TplanScheme \n" +
            "left join TPlanSchemeChild on TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID \n" +
            "left join (select TNewStru7743.sowStrID, max(TDelivery.FdateDelivery) as 'YWRQ' from TDelivery \n" +
            "left join TNewStru7743 on TDelivery.FID=TNewStru7743.FDeliveryMainStruID \n" +
            "where TDelivery.FlogStateE in (3,4,6,12) group by TNewStru7743.sowStrID ) tmp_tbl on datediff(dd,tmp_tbl.YWRQ,getdate())<=TplanScheme.Fdays \n" +
            "left join TPigArchives on tmp_tbl.sowStrID=TPigArchives.FID \n" +
            "where TplanScheme.FcountType=3 and TPigArchives.FPIGSTATEE not in(8,9,18,17,7,12,13) \n" +
            "and (dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)>=?1 and dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)<=?2) \n" +
            "and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) \n" +
            "and (TPigArchives.FPARITYINT between TplanScheme.FPARITYFIRST and TplanScheme.FPARITYLAST)\n" +
            "union all  \n" +
            "select \n" +
            "TPigArchives.hogpenWhereDID,TPigArchives.homesNoDID,TPigArchives.Fnumber as '猪只编码',TPigArchives.FNUMBER15 as '耳缺号',1 as '猪只数量',CASE WHEN  TplanScheme.FplanType=1 THEN '免疫计划' WHEN TplanScheme.FplanType=2 THEN '转舍计划' WHEN TplanScheme.FplanType=3 THEN '日常计划' WHEN TplanScheme.FplanType=4 THEN '保健计划' END as '计划类型',TplanScheme.FplanName as '计划名称', \n" +
            "TPlanSchemeChild.FmaterielName,TPlanSchemeChild.FmaterielType,TPlanSchemeChild.Fproduce,TPlanSchemeChild.Fmeasurement,TPlanSchemeChild.FmedicineAcount,dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ) as '计划时间' ,TPigArchives.FPARITYINT as '胎次',FDAYAGE\n" +
            "from TplanScheme \n" +
            "left join TPlanSchemeChild on TPlanSchemeChild.FPlanSchemeMainStruID=TPlanScheme.FID \n" +
            "left join (select TWeaningNewStru.sowStrID, max(TWeaning.FdateWeaning) as 'YWRQ' from TWeaning \n" +
            "left join TWeaningNewStru on TWeaning.FID=TWeaningNewStru.FWeaningMainStruID \n" +
            "where TWeaning.FlogStateE in (3,4,6,12) group by TWeaningNewStru.sowStrID ) tmp_tbl on datediff(dd,tmp_tbl.YWRQ,getdate())<=TplanScheme.Fdays \n" +
            "left join TPigArchives on tmp_tbl.sowStrID=TPigArchives.FID  \n" +
            "where TplanScheme.FcountType=4 and TPigArchives.FPIGSTATEE not in(8,9,18,17) \n" +
            "and (dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)>=?1 and dateadd(dd,TplanScheme.Fdays,tmp_tbl.YWRQ)<=?2 ) \t\t\t\n" +
            "and( Tplanscheme.orgbelongid =TPigArchives.hogpenWhereDID  or  Tplanscheme.orgbelongid is null) \n" +
            "and (TPigArchives.FPARITYINT between TplanScheme.FPARITYFIRST and TplanScheme.FPARITYLAST)\n" +
            ")tbl \n" +
            "left join TPigHouse on tbl.homesNoDID=TPigHouse.FID \n" +
            "left join TOrganizeCell on tbl.hogpenWhereDID=TOrganizeCell.FID \n" +
            "left join TPigArchives on tbl.猪只编码 = TPigArchives.FNUMBER\n" +
            "where tbl.计划时间 >= getDate() \n" +
            "group by tbl.计划类型,TOrganizeCell.FName ")
    List<Object[]> getWorkPlan1(Date startDate,Date endDate);

    //母猪和仔猪状态
    @Query(nativeQuery = true,value ="select TOrganizeCell.FSHORTNAME,SUM(case when FPIGSTATEE=5 and FCHANGEDAYS>=107 then 1 else 0 end) as '待分娩',\n" +
            "  SUM(case when  FPIGSTATEE=6  and FCHANGEDAYS>20 then 1 else 0 end) as '待断奶',\n" +
            "   SUM(case when FPIGSTATEE in (3,7,12,13) then 1 else 0 end) as '待配种'\n" +
            "  from TPigArchives,TOrganizeCell\n" +
            "  where TOrganizeCell.FID=TPigArchives.HOGPENWHEREDID\n" +
            "  group by FSHORTNAME")
    List<Object[]> getPrepareStatusQuantity();

    //应付排名
    @Query(nativeQuery = true,value ="select * from\n" +
            " (SELECT  RANK() OVER(PARTITION BY  TOrganizeCell.FSHORTNAME  ORDER BY SUM(TpayableChild.FPAYABLEMONEY) desc) AS 排名, TOrganizeCell.FSHORTNAME ,  SUM(TpayableChild.FPAYABLEMONEY) as 金额,TProvider.FNAME from TPayAbles,TpayableChild,TProvider,TOrganizeCell\n" +
            " where TPayAbles.PROVIDERID=TProvider.FID\n" +
            " and TpayableChild.FPayAblesMainStruID=TPayAbles.FID and TOrganizeCell.FID=TPayAbles.CREATEORGUNITID\n" +
            " group by TProvider.FNAME,TOrganizeCell.FSHORTNAME  )t\n" +
            " where t.排名<=5\n")
    List<Object[]> getPayable();

    //销售数据
    @Query(nativeQuery = true,value ="select TOrganizeCell.fshortname,SUM (case when datediff(day,FSALEDATE,getdate())=0 then \n" +
            " isnull(TWarePigSaleChild.FnormalPigAmount,0)+isnull(TWarePigSaleChild.FweakPigAmount,0 )END) as 今日数量,\n" +
            " SUM (case when datediff(day,FSALEDATE,getdate())=0 then \n" +
            " TWarePigSaleChild.FtotalWeight END) as 今日重量,\n" +
            " SUM (case when datediff(day,FSALEDATE,getdate())=0 then \n" +
            " TWarePigSaleChild.FTOTALPRICE END) as 今日金额,\n" +
            " SUM (case when datediff(week,FSALEDATE,getdate())=0 then \n" +
            " isnull(TWarePigSaleChild.FnormalPigAmount,0)+isnull(TWarePigSaleChild.FweakPigAmount,0 )END) as 本周数量,\n" +
            " SUM (case when datediff(week,FSALEDATE,getdate())=0 then \n" +
            " TWarePigSaleChild.FtotalWeight END) as 本周重量,\n" +
            " SUM (case when datediff(week,FSALEDATE,getdate())=0 then \n" +
            " TWarePigSaleChild.FTOTALPRICE END) as 本周金额,\n" +
            " SUM (case when datediff(month,FSALEDATE,getdate())=0 then \n" +
            " isnull(TWarePigSaleChild.FnormalPigAmount,0)+isnull(TWarePigSaleChild.FweakPigAmount,0 )END) as 本月数量,\n" +
            " SUM (case when datediff(month,FSALEDATE,getdate())=0 then \n" +
            " TWarePigSaleChild.FtotalWeight END) as 本月重量,\n" +
            " SUM (case when datediff(month,FSALEDATE,getdate())=0 then \n" +
            " TWarePigSaleChild.FTOTALPRICE END) as 本月金额\n" +
            " FROM TWarePigSale \n" +
            " LEFT JOIN TWarePigSaleChild ON TWarePigSaleChild.FWarePigSaleMainStruID=TWarePigSale.FID \n" +
            " left join TOrganizeCell on TOrganizeCell.FID=TWarePigSale.HOGPENID\n" +
            " WHERE TWarePigSale.FbillState IN(3,4,6)\n" +
            " AND TWarePigSale.FSALEMODE=0 \n" +
            " group by TOrganizeCell.fshortname")
    List<Object[]> getSales();
}